import sys
import numpy as np
import os
import h5py
import multiprocessing as mp
from glob import glob
from collections import Counter
# from sklearn import cross_validation
# /home/ctw/anaconda2/lib/python2.7/site-packages/sklearn/cross_validation.py:44: DeprecationWarning: This module was deprecated in version 0.18 in favor of the model_selection module into which all the refactored classes and functions are moved. Also note that the interface of the new CV iterators are different from that of this module. This module will be removed in 0.20.
#   "This module will be removed in 0.20.", DeprecationWarning)
import cPickle as pickle
from sklearn.metrics import roc_curve, auc
from matplotlib import pyplot as plt
from collections import namedtuple
from scipy import stats
import seaborn as sns
sns.set_style('white')
sns.set_style("ticks")
import matplotlib.gridspec as gridspec
import matplotlib as mpl
import scipy.stats.distributions as dists
mpl.rcParams['pdf.fonttype'] = 42
mpl.rcParams['ps.fonttype'] = 42

# if > 0 use multiprocessing, otherwise regular single-process
# execution:
sys.path.append('/home/ctw/lib/python')
# from get_bipolar_subj_elecs import get_bipolar_subj_elecs
from ptsa.data.events import Events

# run_on_rhino = True
run_on_rhino = False
# experiment = 'catFR1'

if run_on_rhino:
    num_mp_procs = 0
    rhino_mount = ''
else:
    num_mp_procs = 0  # 12
    rhino_mount = '/home/ctw/fusemounts/rhino'

# evfile_date = '20160802'
# evfile_date = '20161101'
# evfile_date = '20170201'
# evfile_date = '20170411_jim'
evfile_date = '20180109_jim'
evfiles = {'catFR1': (rhino_mount+
                      '/home1/cweidema/Christoph/Analyses/RAM/RAM_catFR/data/'+
                      'RAM_catFR1_events'+evfile_date+'.npy'),
           'FR1': (rhino_mount+
                   '/home1/cweidema/Christoph/Analyses/RAM/RAM_FR/data/'+
                   'RAM_FR1_events'+evfile_date+'.npy')
}

evs = {exp: Events(np.load(evfiles[exp])) for exp in evfiles}

# subj_bothexp = set(evs['catFR1']['subject']).intersection(evs['FR1']['subject'])
# # R1191J had different montages for the catFR1 and FR1 sessions, so
# # excluding:
# subj_bothexp.remove('R1191J')


# # OLD:
# sub_pow_old = {'R1026D', 'R1031M', 'R1032D', 'R1035M', 'R1036M', 'R1039M',
#            'R1042M', 'R1045E', 'R1050M', 'R1056M', 'R1060M', 'R1061T',
#            'R1065J', 'R1066P', 'R1069M', 'R1074M', 'R1075J', 'R1089P',
#            'R1102P', 'R1105E', 'R1106M', 'R1111M', 'R1112M', 'R1114C',
#            'R1131M', 'R1147P', 'R1158T', 'R1163T', 'R1167M', 'R1169P',
#            'R1170J', 'R1171M', 'R1174T', 'R1176M', 'R1178P', 'R1184M',
#            'R1189M', 'R1201P', 'R1202M', 'R1204T', 'R1207J', 'R1215M',
#            'R1217T', 'R1222M', 'R1228M', 'R1230J', 'R1231M', 'R1243T',
#            'R1251M', 'R1260D', 'R1264P', 'R1274T', 'R1275D', 'R1277J',
#            'R1291M', 'R1293P', 'R1302M', 'R1310J', 'R1313J', 'R1315T',
#            'R1317D', 'R1321M', 'R1324M', 'R1328E', 'R1330D', 'R1332M',
#            'R1334T', 'R1337E', 'R1338T', 'R1342M', 'R1347D', 'R1351M',
#            'R1364C', 'R1367D', 'R1368T', 'R1375C', 'R1377M', 'R1378T',
#            'R1379E', 'R1381T'}

sub_pow = {'R1026D', 'R1031M', 'R1035M', 'R1036M', 'R1042M', 'R1050M',
           'R1056M', 'R1060M', 'R1061T', 'R1065J', 'R1066P', 'R1069M',
           'R1074M', 'R1075J', 'R1089P', 'R1102P', 'R1105E', 'R1106M',
           'R1111M', 'R1112M', 'R1114C', 'R1131M', 'R1135E', 'R1147P',
           'R1158T', 'R1163T', 'R1167M', 'R1169P', 'R1170J', 'R1174T',
           'R1176M', 'R1178P', 'R1184M', 'R1189M', 'R1201P', 'R1202M',
           'R1204T', 'R1207J', 'R1215M', 'R1217T', 'R1222M', 'R1228M',
           'R1230J', 'R1231M', 'R1243T', 'R1251M', 'R1260D', 'R1264P',
           'R1274T', 'R1275D', 'R1277J', 'R1291M', 'R1293P', 'R1302M',
           'R1310J', 'R1313J', 'R1315T', 'R1317D', 'R1321M', 'R1324M',
           'R1328E', 'R1330D', 'R1332M', 'R1334T', 'R1337E', 'R1338T',
           'R1342M', 'R1347D', 'R1351M'}


evs_bothexp = {
    exp: evs[exp][
        np.array([subj in sub_pow for subj in evs[exp]['subject']])]
    for exp in evfiles
    }

# Remove practice lists:
for exp in evs_bothexp:
    evs_bothexp[exp] = evs_bothexp[exp][evs_bothexp[exp]['list'] > 0]

# Remove a stray WORD event in R1171M session: 2, list: 1 :
evs_bothexp['FR1'] = evs_bothexp['FR1'][
    evs_bothexp['FR1']['mstime'] != 1462393979512.0]
# remove incomplete lists:
evs_bothexp['FR1'] = evs_bothexp['FR1'][
    ~((evs_bothexp['FR1']['subject'] == 'R1147P') &
      (evs_bothexp['FR1']['session'] == 0) & (evs_bothexp['FR1']['list']==24))]
evs_bothexp['FR1'] = evs_bothexp['FR1'][
    ~((evs_bothexp['FR1']['subject'] == 'R1302M') &
      (evs_bothexp['FR1']['session'] == 1) & (evs_bothexp['FR1']['list']==18))]
# evs_bothexp['FR1'] = evs_bothexp['FR1'][
#     ~((evs_bothexp['FR1']['subject'] == 'R1191J') &
#       (evs_bothexp['FR1']['session'] == 1) & (evs_bothexp['FR1']['list']==17))]
# # remove repeated list:
# evs_bothexp['catFR1'] = evs_bothexp['catFR1'][
#     ~((evs_bothexp['catFR1']['subject'] == 'R1191J') &
#       (evs_bothexp['catFR1']['session'] == 0) & (evs_bothexp['catFR1']['list']==12))]


def add_yoked_category(events):
    # events['FR1'].add_fields(category=events['catFR1']['category'].dtype)
    for subj in np.unique(events['FR1']['subject']):
        subj_indx = ((events['FR1']['subject'] == subj) &
                     (events['FR1']['type'] == 'WORD'))
        subj_indx_rec = ((events['FR1']['subject'] == subj) &
                         (events['FR1']['type'] == 'REC_WORD'))
        subj_indx_catFR = ((events['catFR1']['subject'] == subj) &
                           (events['catFR1']['type'] == 'WORD'))
        sess_catFR = np.unique(events['catFR1']['session'][subj_indx_catFR])
        for s, sess in enumerate(
                np.unique(events['FR1']['session'][subj_indx])):
            subjsess_indx = subj_indx & (events['FR1']['session'] == sess)
            subjsess_indx_rec = subj_indx_rec & (
                events['FR1']['session'] == sess)
            subjsess_indx_catFR = subj_indx_catFR & (
                events['catFR1']['session'] == sess_catFR[s%len(sess_catFR)])
            lst_catFR = np.unique(
                events['catFR1']['list'][subjsess_indx_catFR])
            for l, lst in enumerate(
                    np.unique(events['FR1']['list'][subjsess_indx])):
                subjsesslst_indx = (subjsess_indx &
                                    (events['FR1']['list'] == lst))
                subjsesslst_indx_rec = (subjsess_indx_rec &
                                        (events['FR1']['list'] == lst))
                subjsesslst_indx_catFR = (subjsess_indx_catFR &
                                          (events['catFR1']['list'] ==
                                           lst_catFR[l%len(lst_catFR)]))
                # if subjsesslst_indx.sum() != 12:
                #     print subj, sess, lst, subjsesslst_indx.sum()
                #     # R1147P 0 24 7
                #     # R1171M 2 1 13#
                # while subjsesslst_indx_catFR.sum() != 12:
                #     l+=1
                #     subjsesslst_indx_catFR = (subjsess_indx_catFR &
                #                               (events['catFR1']['list'] ==
                #                                lst_catFR[l%len(lst_catFR)]))
                #     if l > 30:
                #         raise ValueError('Infinite Loop!')
                # if subjsesslst_indx.sum() < subjsesslst_indx_catFR.sum():
                #     subjsesslst_indx_catFR[subjsesslst_indx_catFR][subjsesslst_indx.sum():] = False
                #     print  subjsesslst_indx.sum(), subjsesslst_indx_catFR.sum()
                # if  subjsesslst_indx.sum() <= subjsesslst_indx_catFR.sum():
                if subjsesslst_indx.sum() > subjsesslst_indx_catFR.sum():
                    subjsesslst_indx_catFR = subjsess_indx_catFR
                events['FR1']['category'][subjsesslst_indx] = events[
                    'catFR1']['category'][subjsesslst_indx_catFR][
                        :subjsesslst_indx.sum()]
                for item in events['FR1']['item'][subjsesslst_indx_rec]:
                    study_item_indx = ((events['FR1']['item'] == item) &
                                       subjsesslst_indx)
                    # if study_item_indx.sum() == 0:
                    if study_item_indx.sum() == 0:
                        continue
                    rec_item_indx = ((events['FR1']['item'] == item) &
                                     subjsesslst_indx_rec)
                    events['FR1']['category'][rec_item_indx] = events[
                        'FR1']['category'][study_item_indx]
                    # # take care of repetitions by using repeat:
                    # events['FR1']['category'][rec_item_indx] = np.repeat(events[
                    #     'FR1']['category'][study_item_indx], rec_item_indx.sum())


add_yoked_category(evs_bothexp)



def add_irt(events):
    recfilt = (events['intrusion'] == 0) & (events['repeat'] == 0) & (events['type'] == 'REC_WORD')
    events = events.add_fields(irt=np.ones(len(events))*np.nan,
                               num_recalls=np.ones(len(events))*np.nan)

    for subj in np.unique(events['subject']):
        for sess in np.unique(events[events['subject'] == subj]['session']):
            for lst in np.unique(events[
                    (events['subject'] == subj) &
                    (events['session'] == sess)]['list']):

                filt = ((events['subject'] == subj) & (events['session'] == sess) &
                            (events['list'] == lst))

                if np.sum(filt & recfilt) > 1:
                    rectimes = [events[filt & recfilt]['rectime']]
                    irt = np.diff(rectimes)
                    irt = np.insert(irt, 0, 0)
                else:
                    irt = [0]

                num_recalls = np.ones(len(irt))*len(irt)

                events['irt'][filt & recfilt] = irt
                events['num_recalls'][filt & recfilt] = num_recalls

                events['irt'][filt & recfilt & (events['irt'] == 0)] = np.nan
    return events

evs_bothexp = {exp: add_irt(evs_bothexp[exp]) for exp in evs_bothexp}

def get_irt_by_filt(evs, recfilt=None):

    if recfilt is None:
        recfilt = (evs['type'] == 'REC_WORD') & (evs['intrusion'] == 0) & (evs['repeat'] == 0)

    all_irt = []
    for subj in np.unique(evs['subject']):
        subjfilt = evs['subject'] == subj
        subjirt = np.nanmean(evs[subjfilt & recfilt]['irt'], 0)
        all_irt.append(subjirt)

    return all_irt




# def categorize_intrusions(events):
#     english_pools = np.sort(glob('/home/ctw/src/RAM_catFR/pools_EN/*.txt'))
#     spanish_pools = np.sort(glob('/home/ctw/src/RAM_catFR/pools_SP/*.txt'))
#     pools = [english_pools,spanish_pools]
#     chars_old = unicode('ÁÉÍÓÚÑáéíóúñ',encoding='utf-8') # u'ÁÉÍÓÚÑáéíóúñ'
#     chars_new = unicode('AEIOUNaeioun',encoding='utf-8') #u'AEIOUNaeioun'
#     # for expname in events:
#     # recevs = events[expname][events[expname]['type']=='REC_WORD']
#     recfilt = events['type']=='REC_WORD'
#     for xli in np.unique(events[
#             recfilt & (events['intrusion']==-1)]['item']):
#     # for xli in np.unique(events[events['intrusion']==-1]['item']):
#     # for xli in np.unique(recevs[recevs['intrusion']==-1]['item']):
#         found_word = False
#         for pool in pools:
#             if found_word:
#                 break
#             for cat_num,cat_file in enumerate(pool):
#                 cat_name = cat_file.split('/')[-1][:-4]
#                 cat_words = [cw.strip() for cw in codecs.open(
#                     cat_file, encoding='utf-8',mode='r').readlines()]
#                 for i,cw in enumerate(cat_words):
#                     for c, char in enumerate(chars_old):
#                         cw = cw.replace(char, chars_new[c])
#                     cat_words[i] = cw
#                 if xli in cat_words:
#                     events['category'][
#                         recfilt & (events['item']==xli)] = cat_name
#                     events['categoryNum'][
#                         recfilt & (events['item']==xli)] = cat_num
#                     found_word = True
#                     break
#                 # elif xli in xli_cats[cat_name]:
#                 #     events['category'][events['item']==xli] = cat_name
#                 #     events['categoryNum'][events['item']==xli] = cat_num

#     for pli in np.unique(events[
#             recfilt & (events['intrusion']>0)]['item']):
#         found_word = False
#         for pool in pools:
#             if found_word:
#                 break
#             for cat_num,cat_file in enumerate(pool):
#                 cat_name = cat_file.split('/')[-1][:-4]
#                 cat_words = [cw.strip() for cw in codecs.open(
#                     cat_file, encoding='utf-8',mode='r').readlines()]
#                 for i, cw in enumerate(cat_words):
#                     for c, char in enumerate(chars_old):
#                         cw = cw.replace(char, chars_new[c])
#                     cat_words[i] = cw
#                 if pli in cat_words:
#                     events['category'][
#                         recfilt & (events['item']==pli)] = cat_name
#                     events['categoryNum'][
#                         recfilt & (events['item']==pli)] = cat_num
#                     found_word = True
#                     break            



# def add_catcluster_fields(events):                
#     recfilt = (events['type'] == 'REC_WORD') # & (events['intrusion'] == 0)
#     events = events.add_fields(ratio_of_rep=np.ones(len(events))*np.nan,
#                                num_rec=np.ones(len(events))*np.nan,
#                                num_intrusions=np.ones(len(events))*np.nan,
#                                num_repetitions=np.ones(len(events))*np.nan,
#                                cluster_train=np.ones(len(events))*np.nan)

#     for subj in np.unique(events['subject']):
#         for sess in np.unique(events[events['subject'] == subj]['session']):
#             for lst in np.unique(events[
#                     (events['subject'] == subj) &
#                     (events['session'] == sess)]['list']):
#                 filt = ((events['subject'] == subj) & (events['session'] == sess) &
#                         (events['list'] == lst))
#                 rep_counter = 0.0
#                 # invalid_counter = 0.0
#                 repetition_counter = 0.0
#                 intrusion_counter = 0.0
#                 cluster_train = np.zeros(np.sum(filt & recfilt))
#                 if np.sum(filt & recfilt)>1:
#                     rec_words = [events[filt & recfilt]['item'][0]]
#                     prev_cat_label = events[filt & recfilt]['category'][0]
#                     for  i, (rec_word, cat_label, intrusion) in enumerate(zip(
#                             events[filt & recfilt]['item'][1:],
#                             events[filt & recfilt]['category'][1:],
#                             events[filt & recfilt]['intrusion'][1:])):
#                         if rec_word in rec_words:
#                             # prev_cat_label = cat_label
#                             repetition_counter += 1
#                         elif intrusion != 0:
#                             # prev_cat_label = cat_label
#                             intrusion_counter += 1
#                         # if (prev_cat_label == 'X') or (cat_label == 'X'):
#                         #     prev_cat_label = cat_label
#                         elif (cat_label != 'X') & (cat_label == prev_cat_label):
#                             rep_counter += 1.0
#                             rec_words.append(rec_word)
#                             if cluster_train[i] == 0:
#                                 cluster_train[i] = 1.0
#                                 events['cluster_train'][
#                                     filt & (events[
#                                         'item']==events[
#                                             filt & recfilt][
#                                                 'item'][i])] = 1.0
#                             cluster_train[i+1] = cluster_train[i]+1.0
#                             events['cluster_train'][
#                                 filt & (events[
#                                     'item']==rec_word)] = cluster_train[i]+1.0
#                         prev_cat_label = cat_label
#                         rec_words.append(rec_word)
                            
#                     # rr = rep_counter / (np.sum(filt & recfilt)-invalid_counter)
#                     if (np.sum(filt & recfilt)-
#                         repetition_counter-intrusion_counter) <= 1:
#                         rr = 0.0
#                     else:
#                         # added the -1 in denominator (had forgotten initially):
#                         rr = rep_counter / (np.sum(filt & recfilt)-
#                                             repetition_counter-
#                                             intrusion_counter-1)
#                 else:
#                     rr = 0.0   
#                 events['ratio_of_rep'][filt] = rr
#                 events['num_rec'][filt] = (np.sum(filt & recfilt)-
#                                            repetition_counter-intrusion_counter)
#                 events['num_intrusions'][filt] = intrusion_counter
#                 events['num_repetitions'][filt] = repetition_counter
#                 events['cluster_train'][filt & recfilt] = cluster_train
#     return(events)

# def add_catcluster_fields(events):
#     recfilt = (events['type'] == 'REC_WORD')
#     events = events.add_fields(ratio_of_rep=np.ones(len(events))*np.nan,
#                                ratio_of_rep_near=np.ones(len(events))*np.nan,
#                                ratio_of_rep_far=np.ones(len(events))*np.nan,
#                                num_rec=np.ones(len(events))*np.nan,
#                                num_intrusions=np.ones(len(events))*np.nan,
#                                num_repetitions=np.ones(len(events))*np.nan,
#                                cluster_train=np.ones(len(events))*np.nan)

#     for subj in np.unique(events['subject']):
#         for sess in np.unique(events[events['subject'] == subj]['session']):
#             for lst in np.unique(events[
#                     (events['subject'] == subj) &
#                     (events['session'] == sess)]['list']):
#                 filt = ((events['subject'] == subj) & (events['session'] == sess) &
#                         (events['list'] == lst))

#                 rep_counter = 0.0
#                 rep_near_counter = 0.0
#                 rep_far_counter = 0.0

#                 # invalid_counter = 0.0
#                 repetition_counter = 0.0
#                 intrusion_counter = 0.0
#                 cluster_train = np.zeros(np.sum(filt & recfilt))
#                 if np.sum(filt & recfilt)>1:
#                     rec_words = [events[filt & recfilt]['item'][0]]
#                     prev_cat_label = events[filt & recfilt]['category'][0]

#                     # compute serial positions and lags of all recalled items in this list
#                     pres_items = events[(filt) & (events['type']=='WORD')]['item']
#                     rec_items = events[filt & recfilt]['item']

#                     rec_spos = []
#                     for rw in rec_items:
#                         if np.where(pres_items == rw)[0].size != 0:
#                             pos = np.where(pres_items == rw)[0][0]+1
#                         else:
#                             pos = np.nan
#                         rec_spos.append(pos)

#                     rec_lags = np.diff(rec_spos)

#                     for i, (rec_word, cat_label, intrusion) in enumerate(zip(
#                             events[filt & recfilt]['item'][1:],
#                             events[filt & recfilt]['category'][1:],
#                             events[filt & recfilt]['intrusion'][1:])):
#                         if rec_word in rec_words:
#                             # prev_cat_label = cat_label
#                             repetition_counter += 1
#                         elif intrusion != 0:
#                             # prev_cat_label = cat_label
#                             intrusion_counter += 1
#                         # if (prev_cat_label == 'X') or (cat_label == 'X'):
#                         #     prev_cat_label = cat_label
#                         elif (cat_label != 'X') & (cat_label == prev_cat_label):
#                             rep_counter += 1.0

#                             # add two new counters here
#                             if np.abs(rec_lags[i]) < 2: # one for category repeat with small temporal distance (abs(lag) < 2):
#                                 rep_near_counter += 1.0
#                             else: # one for category repeat with large temporal distance (abs(lag) >= 2):
#                                 rep_far_counter += 1.0

#                             rec_words.append(rec_word)
#                             if cluster_train[i] == 0:
#                                 cluster_train[i] = 1.0
#                                 events['cluster_train'][
#                                     filt & (events[
#                                         'item']==events[
#                                             filt & recfilt][
#                                                 'item'][i])] = 1.0
#                             cluster_train[i+1] = cluster_train[i]+1.0
#                             events['cluster_train'][
#                                 filt & (events[
#                                     'item']==rec_word)] = cluster_train[i]+1.0

#                         prev_cat_label = cat_label
#                         rec_words.append(rec_word)

#                     # rr = rep_counter / (np.sum(filt & recfilt)-invalid_counter)
#                     if (np.sum(filt & recfilt)-
#                         repetition_counter-intrusion_counter) <= 1:
#                         rr = 0.0
#                         rr_near = 0.0
#                         rr_far = 0.0
#                     else:
#                         # added the -1 in denominator (had forgotten initially):
#                         rr = rep_counter / (np.sum(filt & recfilt)-
#                                             repetition_counter-
#                                             intrusion_counter-1)

#                         rr_near = rep_near_counter / (np.sum(filt & recfilt)-
#                                             repetition_counter-
#                                             intrusion_counter-1)

#                         rr_far = rep_far_counter / (np.sum(filt & recfilt)-
#                                             repetition_counter-
#                                             intrusion_counter-1)
#                 else:
#                     rr = 0.0
#                     rr_near = 0.0
#                     rr_far = 0.0

#                 events['ratio_of_rep'][filt] = rr
#                 events['ratio_of_rep_near'][filt] = rr_near
#                 events['ratio_of_rep_far'][filt] = rr_far
#                 events['num_rec'][filt] = (np.sum(filt & recfilt)-
#                                            repetition_counter-intrusion_counter)
#                 events['num_intrusions'][filt] = intrusion_counter
#                 events['num_repetitions'][filt] = repetition_counter
#                 events['cluster_train'][filt & recfilt] = cluster_train
#     return(events)


def add_catcluster_fields(events):
    recfilt = (events['type'] == 'REC_WORD')
    events = events.add_fields(ratio_of_rep=np.ones(len(events))*np.nan,
                               ratio_of_rep_near=np.ones(len(events))*np.nan,
                               ratio_of_rep_far=np.ones(len(events))*np.nan,
                               arc=np.ones(len(events))*np.nan,
                               arc_near=np.ones(len(events))*np.nan,
                               arc_far=np.ones(len(events))*np.nan,
                               num_rec=np.ones(len(events))*np.nan,
                               num_intrusions=np.ones(len(events))*np.nan,
                               num_repetitions=np.ones(len(events))*np.nan,
                               cluster_train=np.ones(len(events))*np.nan)

    for subj in np.unique(events['subject']):
        for sess in np.unique(events[events['subject'] == subj]['session']):
            for lst in np.unique(events[
                    (events['subject'] == subj) &
                    (events['session'] == sess)]['list']):
                filt = ((events['subject'] == subj) & (events['session'] == sess) &
                        (events['list'] == lst))

                rep_counter = 0.0 # category repetitions
                rep_near_counter = 0.0
                rep_far_counter = 0.0
                category_counter = Counter()

                # invalid_counter = 0.0
                repetition_counter = 0.0  # repeated recall of same word
                intrusion_counter = 0.0
                cluster_train = np.zeros(np.sum(filt & recfilt))
                cat_labels = set()
                rec_words = set()
                if np.sum(filt & recfilt)>1:
                    rec_words.add(events[filt & recfilt]['item'][0])
                    prev_cat_label = events[filt & recfilt]['category'][0]
                    if prev_cat_label != 'X':
                        category_counter[prev_cat_label] += 1

                    # compute serial positions and lags of all recalled items in this list
                    pres_items = events[(filt) & (events['type']=='WORD')]['item']
                    rec_items = events[filt & recfilt]['item']

                    rec_spos = []
                    for rw in rec_items:
                        if np.where(pres_items == rw)[0].size != 0:
                            pos = np.where(pres_items == rw)[0][0]+1
                        else:
                            pos = np.nan
                        rec_spos.append(pos)

                    rec_lags = np.diff(rec_spos)

                    for i, (rec_word, cat_label, intrusion) in enumerate(zip(
                            events[filt & recfilt]['item'][1:],
                            events[filt & recfilt]['category'][1:],
                            events[filt & recfilt]['intrusion'][1:])):
                        if ((cat_label != 'X') and (rec_word not in rec_words)
                            and (intrusion == 0)):
                            category_counter[cat_label] += 1
                        if rec_word in rec_words:
                            # prev_cat_label = cat_label
                            repetition_counter += 1
                        elif intrusion != 0:
                            # prev_cat_label = cat_label
                            intrusion_counter += 1
                        # if (prev_cat_label == 'X') or (cat_label == 'X'):
                        #     prev_cat_label = cat_label
                        elif (cat_label != 'X') & (cat_label == prev_cat_label):
                            rep_counter += 1.0
                            # add two new counters here
                            # one for category repeat with small temporal distance (abs(lag) < 2):
                            if np.abs(rec_lags[i]) < 2: 
                                rep_near_counter += 1.0
                            else: # one for category repeat with large temporal distance (abs(lag) >= 2):
                                rep_far_counter += 1.0
                            # rec_words.append(rec_word)
                            if cluster_train[i] == 0:
                                cluster_train[i] = 1.0
                                events['cluster_train'][
                                    filt & (events[
                                        'item']==events[
                                            filt & recfilt][
                                                'item'][i])] = 1.0
                            cluster_train[i+1] = cluster_train[i]+1.0
                            events['cluster_train'][
                                filt & (events[
                                    'item']==rec_word)] = cluster_train[i]+1.0

                        prev_cat_label = cat_label
                        rec_words.add(rec_word)

                    # rr = rep_counter / (np.sum(filt & recfilt)-invalid_counter)
                    num_recalled = (np.sum(filt & recfilt)-
                                    repetition_counter-intrusion_counter)
                    if ((num_recalled <= 1) or
                        (num_recalled == len(category_counter))):
                        rr = 0.0
                        rr_near = 0.0
                        rr_far = 0.0
                        arc = 0.0
                        arc_near = 0.0
                        arc_far = 0.0
                    else:
                        rr = rep_counter / (num_recalled-1)
                        rr_near = rep_near_counter / (num_recalled-1)
                        rr_far = rep_far_counter / (num_recalled-1)
                        # e_r = ((np.sum(np.array(category_counter.values())**2) /
                        #        num_recalled) -
                        #        (1 + repetition_counter + intrusion_counter))
                        e_r = ((np.sum(np.array(category_counter.values())*
                                       (np.array(category_counter.values())-1)) /
                                (num_recalled +
                                 repetition_counter + intrusion_counter)))
                        max_r = num_recalled - len(category_counter)
                        if max_r == e_r:
                            arc = 0.0
                            arc_near = 0.0
                            arc_far = 0.0
                        else:
                            arc = (rep_counter - e_r) / (max_r - e_r)
                            arc_near = (rep_near_counter - e_r) / (max_r - e_r)
                            arc_far = (rep_far_counter-e_r) / (max_r - e_r)
                else:
                    rr = 0.0
                    rr_near = 0.0
                    rr_far = 0.0
                    arc = 0.0
                    arc_near = 0.0
                    arc_far = 0.0

                events['ratio_of_rep'][filt] = rr
                events['ratio_of_rep_near'][filt] = rr_near
                events['ratio_of_rep_far'][filt] = rr_far
                events['arc'][filt] = arc
                events['arc_near'][filt] = arc_near
                events['arc_far'][filt] = arc_far
                events['num_rec'][filt] = (np.sum(filt & recfilt)-
                                           repetition_counter-intrusion_counter)
                events['num_intrusions'][filt] = intrusion_counter
                events['num_repetitions'][filt] = repetition_counter
                events['cluster_train'][filt & recfilt] = cluster_train
    return(events)

# evs_allcatFR = add_catcluster_fields(evs['catFR1'])
# np.save('evs_allcatFR.npy', evs_allcatFR)


# categorize_intrusions(evs_bothexp['catFR1'])
evs_bothexp_cluster = {exp: add_catcluster_fields(evs_bothexp[exp])
                       for exp in evs_bothexp}
# import cPickle as pickle
# pickle.dump(evs_bothexp_cluster, open('evs_bothexp_cluster.pickle', 'w'), -1)

# fig_rows = 1
# fig_cols = 1
# fig, axs = plt.subplots(nrows=fig_rows, ncols=fig_cols, sharex=True,
#                         sharey=True, figsize=(10, 4))
wordfilt = {exp: evs_bothexp_cluster[exp]['type'] == 'WORD'
            for exp in evs_bothexp_cluster}
# behavioral_indices = {'ratio_of_rep': [], 'num_rec': [], 'num_intrusions': [], 'num_repetitions': []}

# behavioral_indices = {}
# for exp in evs_bothexp_cluster:
#     behavioral_indices[exp] = {'recalled': [], 'ratio_of_rep': [], 'num_rec': [],
#                                'num_intrusions': [], 'num_repetitions': []}
#     for subj in np.unique(evs_bothexp_cluster[exp]['subject']):
#         subjfilt = evs_bothexp_cluster[exp]['subject'] == subj
#         for bh in behavioral_indices[exp]:
#             # if bh == 'prec':
#             #     behavioral_indices[exp][bh].extend([evs_bothexp_cluster[exp][
#             #         wordfilt[exp] & subjfilt]['recalled'].mean()
#             # else:
#             behavioral_indices[exp][bh].extend([evs_bothexp_cluster[exp][
#                 wordfilt[exp] & subjfilt][
#                     bh].mean()])
#     for bh in behavioral_indices[exp]:
#         behavioral_indices[exp][bh] = np.array(behavioral_indices[exp][bh])


behavioral_indices = {}
for exp in evs_bothexp_cluster:
    behavioral_indices[exp] = {'recalled': [], 'ratio_of_rep': [],
                               'ratio_of_rep_near': [], 'ratio_of_rep_far': [],
                               'arc': [], 'arc_near': [], 'arc_far': [], 'num_rec': [],
                               'num_intrusions': [], 'num_repetitions': []}
    for subj in np.unique(evs_bothexp_cluster[exp]['subject']):
        subjfilt = evs_bothexp_cluster[exp]['subject'] == subj
        for bh in behavioral_indices[exp]:
            behavioral_indices[exp][bh].extend([evs_bothexp_cluster[exp][
                wordfilt[exp] & subjfilt][
                    bh].mean()])
    for bh in behavioral_indices[exp]:
        behavioral_indices[exp][bh] = np.array(behavioral_indices[exp][bh])



# calculate SPC:

evs_word_bothexp = {}
for label in evs_bothexp:
    evs_word_bothexp[label] = evs_bothexp[label][
        evs_bothexp[label]['type'] == 'WORD']

def get_spc(evs):
    all_recalls = []
    for subj in np.unique(evs['subject']):
        subjrecalls = []
        subjfilt = evs['subject'] == subj
        for sess in np.unique(evs[subjfilt]['session']):
            subjsessfilt = subjfilt & (evs['session'] == sess)
            for lst in np.unique(evs[subjsessfilt]['list']):
                subjsesslstfilt = subjsessfilt & (evs['list'] == lst)
                subjrecalls.append(evs[subjsesslstfilt]['recalled'])
        subjrecalls = np.mean(subjrecalls, 0)
        all_recalls.append(subjrecalls)
    return all_recalls
                

evs_recword_bothexp = {}
for label in evs_bothexp:
    evs_recword_bothexp[label] = evs_bothexp[label][
        evs_bothexp[label]['type'] == 'REC_WORD']


behdat = {'SPC': {'all': {exp: get_spc(evs_word_bothexp[exp])
                          for exp in evs_word_bothexp}}}

for plottype in behdat:
    behdat[plottype]['all'][
        'catFR1-FR1'] = (np.array(behdat[plottype]['all']['catFR1'])-
                         np.array(behdat[plottype]['all']['FR1']))

for plottype in behdat:
    behdat[plottype]['mean'] = {exp: np.nanmean(behdat[plottype]['all'][exp], 0)
                                for exp in behdat[plottype]['all']}
    behdat[plottype]['SE'] = {exp: (np.nanstd(
        behdat[plottype]['all'][exp], 0) / np.sqrt(np.sum(np.isfinite(
            behdat[plottype]['all'][exp]), 0)))
                              for exp in behdat[plottype]['all']}
    behdat[plottype]['CI95'] = {exp: behdat[plottype]['SE'][exp] * stats.t.ppf(
        0.975, np.sum(np.isfinite(behdat[plottype]['all'][exp]), 0)-1)
                                for exp in behdat[plottype]['all']}

import pandas as pd
spc_FR1 = pd.DataFrame.from_dict(behdat['SPC']['all']['FR1'])
spc_catFR1 = pd.DataFrame.from_dict(behdat['SPC']['all']['catFR1'])
spc_df = pd.concat([spc_FR1, spc_catFR1], keys=['FR1', 'catFR1'])

expindx = []
subjindx = []
itemindx = []

for indx in spc_df.stack().index:
    expindx.append(indx[0])
    subjindx.append(indx[1])
    itemindx.append(indx[2])

# spc_anova = np.empty(spc_df.stack().values.shape, dtype=[('subject','i4'), ('experiment', 'U8'), ('serialpos', 'i4'), ('prec', 'f8')])
spc_anova = np.empty(spc_df.stack().values.shape, dtype=[('subject','i4'), ('experiment', 'S8'), ('serialpos', 'i4'), ('prec', 'f8')])
spc_anova['subject'] = subjindx
spc_anova['experiment'] = expindx
spc_anova['serialpos'] = itemindx
spc_anova['prec'] = spc_df.stack().values

spc_anova_df = pd.DataFrame.from_records(spc_anova)

spc_anova_df.to_hdf('spc_data.hdf5', 'spc_data')
spc_anova_df.to_csv('spc_data.csv')

# import rpy2.robjects as robjects
# import rpy2.robjects.packages as rpackages
# from rpy2.robjects.vectors import StrVector

# packageNames = ('afex', 'lsmeans')
 
# if all(rpackages.isinstalled(x) for x in packageNames):
 
#     have_packages = True
 
# else:
 
#    have_packages = False

# if not have_packages:
#     utils = rpackages.importr('utils')
#     utils.chooseCRANmirror(ind=1)
#     packnames_to_install = [x for x in packageNames if not rpackages.isinstalled(x)]
#     if len(packnames_to_install) > 0:
#         utils.install_packages(StrVector(packnames_to_install))

# afex = importr('afex') 
# model = afex.aov_ez('subject', 'prec', data, within='Valence')
# print model



# import pyvttbl as pt
# spc_anova_ptdf = pt.DataFrame(spc_anova_df)
# aov = spc_anova_ptdf.anova('prec', sub='subject',
#                            wfactors=['experiment','serialpos'])


# from statsmodels.formula.api import ols
# from statsmodels.stats.anova import anova_lm
# formula = 'prec ~ C(supp) + C(dose) + C(supp):C(dose)'
# model = ols(formula, data).fit()
# aov_table = anova_lm(model, typ=2)



# spc_df_anova = pd.DataFrame([subjindx, expindx, itemindx, list(spc_df.stack().values)], columns=['subject', 'experiment', 'serialpos', 'prec'])


# datafile="/home/ctw/tmp/ToothGrowth.csv"
# data = pd.read_csv(datafile)

# pd.melt(spc_df, id_vars=['FR1', 'catFR1'])


# spc_df = pd.concat([spc_FR1.T, spc_catFR1.T], keys=['FR1', 'catFR1']).T


# fig, axs = plt.subplots(nrows=2, ncols=4, figsize=(7, 3),
#                         gridspec_kw = {'height_ratios': [5, 2]})
fig = plt.figure(figsize=(8, 3))
gs = gridspec.GridSpec(nrows=2, ncols=3, height_ratios=[5, 2], width_ratios=[4, 3, 5])
ax1 = plt.subplot(gs[0, 0])
ax1.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
                   behdat['SPC']['CI95']['FR1'], fmt='b-', lw=2, alpha=0.8,
                   label='C')
ax1.errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
                   behdat['SPC']['CI95']['FR1'], fmt='g--', lw=2, alpha=0.8,
                   label='U')
ax1.set_xlim((0.5, 12.5))
ax1.set_ylim((0, 0.65))
ax1.set_ylim((0., 0.65))
ax1.set_ylabel('p(recall)')#, size='large')
ax1.xaxis.set_visible(False)
# http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 0].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 0].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)
sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=ax1)
# sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
#axs[0, 0].xaxis.set_tick_params(pad=3)
ax1.yaxis.set_tick_params(pad=3)
# http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
handles, labels = ax1.get_legend_handles_labels()
handles = [h[0] for h in handles]
ax1.legend(handles, labels, loc='upper right',
           frameon=False, borderpad=0)

ax1b = plt.subplot(gs[1, 0])
# fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
ax1b.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
              behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
              lw=2, alpha=0.8)
ax1b.plot([0.5, 12.5], [0, 0], 'k--', lw=2)
ax1b.set_xlim((0.5, 12.5))
ax1b.set_ylim((-0.1, 0.15))
#ax1b.tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
ax1b.set_xticks(range(1, 13))
# ax1b.set_xticklabels(range(1, 13), size='large')
ax1b.set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
ax1b.set_xlabel('Serial position', labelpad=1)
ax1b.set_yticks([-0.1, 0.0, 0.1])
ax1b.set_yticklabels([-0.1, 0.0, 0.1])
ax1b.set_ylabel(r"$\Delta$"+'(p)', labelpad=1)
sns.despine(offset=0, trim=True, ax=ax1b)
# sns.despine(offset=0, ax=ax1b)
ax1b.xaxis.set_tick_params(pad=3)
ax1b.yaxis.set_tick_params(pad=3)

ax2 = plt.subplot(gs[:, 1])
sns.stripplot(data=[behavioral_indices['catFR1']['ratio_of_rep'],
                    behavioral_indices['FR1']['ratio_of_rep']], jitter=True, alpha=0.3, ax=ax2, color='black')
# sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
sns.pointplot(data=[behavioral_indices['catFR1']['ratio_of_rep'],
                    behavioral_indices['FR1']['ratio_of_rep']], ax=ax2, color='black')
#ax.set_xlim((-0.175,1.175))
ax2.set_xlim((-0.3,1.175))
#sns.despine(offset=0, trim=True, ax=ax2)
sns.despine(offset=0, ax=ax2)
ax2.set_xticklabels(['categorized', 'unrelated'])
ax2.set_ylabel('Ratio of repetition')

ax3 = plt.subplot(gs[:, 2], aspect='equal')
# ax3 = plt.subplot2grid((1, 4), (0, 2), colspan=2, aspect='equal')
ax3 = sns.regplot(x=(behavioral_indices['catFR1']['ratio_of_rep']-
                        behavioral_indices['FR1']['ratio_of_rep']),
                     y=(behavioral_indices['catFR1']['recalled']-
                        behavioral_indices['FR1']['recalled']),
                  color='k', ci=95, ax=ax3)
ax3.set_xlabel(r'$\Delta$(ratio of repetition)', labelpad=1)
ax3.set_ylabel(r'$\Delta$p(recall)', labelpad=1)
sns.despine(offset=0, ax=ax3)
fig.subplots_adjust(left=0.07, bottom=0.17,
                    right=0.99999, top=0.999, wspace=0.4 , hspace=0.42)
# plt.savefig('./figures/pub/FRcatFR_SPC_RR.pdf')



#grid.fig.set_size_inches((4,4))
#grid.fig.set_size_inches((2,2))
grid.fig.axes[0].xaxis.set_tick_params(pad=3)
grid.fig.axes[0].yaxis.set_tick_params(pad=3)
grid.fig.axes[0].set_xticks(np.arange(0, 0.61, 0.1))
grid.fig.axes[0].set_xticklabels(np.arange(0, 0.61, 0.1), size='large')
grid.fig.axes[0].set_yticks(np.arange(-0.2, 0.41, 0.1))
grid.fig.axes[0].set_yticklabels(np.arange(-0.2, 0.41, 0.1), size='large')
grid.fig.axes[0].yaxis.set_tick_params(pad=3)
grid.fig.axes[0].set_xlim(-0.05, 0.475)
grid.fig.axes[0].set_ylim(-0.175, 0.35)




evs = evs_bothexp['catFR1']
recfilt_within_all = ((evs['type'] == 'REC_WORD') & (evs['intrusion'] == 0) &
                      (evs['repeat'] == 0) & (evs['within_cat'] == 1))
recfilt_between_all = ((evs['type'] == 'REC_WORD') & (evs['intrusion'] == 0) &
                       (evs['repeat'] == 0) & (evs['between_cat'] == 1))
recfilt_within_match = ((evs['type'] == 'REC_WORD') & (evs['intrusion'] == 0) &
                        (evs['repeat'] == 0) & (evs['within_cat'] == 1) & (evs['pirt'] > 1500))
recfilt_between_match = ((evs['type'] == 'REC_WORD') & (evs['intrusion'] == 0) &
                         (evs['repeat'] == 0) & (evs['between_cat'] == 1) & (evs['pirt'] > 1500))


irts_within = get_irt_by_filt(evs, recfilt_within_all)
irts_between = get_irt_by_filt(evs, recfilt_between_all)
irts_within_match = get_irt_by_filt(evs, recfilt_within_match)
irts_between_match = get_irt_by_filt(evs, recfilt_between_match)

# convert ms to s:
irts_within = np.array(irts_within) / 1000
irts_between = np.array(irts_between) / 1000
irts_within_match = np.array(irts_within_match) / 1000
irts_between_match = np.array(irts_between_match) / 1000







# # fig = plt.figure(figsize=(6.92912, 1.9))
# # gs = gridspec.GridSpec(nrows=2, ncols=4, height_ratios=[3, 1], width_ratios=[6, 5, 5, 7])
# fig = plt.figure(figsize=(6.92912, 1.9))
# gs = gridspec.GridSpec(nrows=2, ncols=4, height_ratios=[3, 1], width_ratios=[5, 5, 5, 7])
# ax1 = plt.subplot(gs[0, 0])
# ax1.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
#                    behdat['SPC']['CI95']['catFR1'], fmt='b-', lw=2, alpha=0.8,
#                    label='C')
# ax1.errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
#                    behdat['SPC']['CI95']['FR1'], fmt='g--', lw=2, alpha=0.8,
#                    label='U')
# ax1.set_xlim((0.5, 12.5))
# ax1.set_ylim((0, 0.65))
# ax1.set_yticks(np.arange(0, 0.7, 0.2))
# ax1.set_ylim((0., 0.65))
# ax1.set_ylabel('p(recall)')#, size='large')
# ax1.xaxis.set_visible(False)
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# # handles, labels = axs[0, 0].get_legend_handles_labels()
# # handles = [h[0] for h in handles]
# # axs[0, 0].legend(handles, labels, loc='upper right',
# #                  frameon=False, borderpad=0)
# sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=ax1)
# # sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# #axs[0, 0].xaxis.set_tick_params(pad=3)
# ax1.yaxis.set_tick_params(pad=3)
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = ax1.get_legend_handles_labels()
# handles = [h[0] for h in handles]
# ax1.legend(handles, labels, loc='upper right',
#            frameon=False, borderpad=0)

# ax1b = plt.subplot(gs[1, 0])
# # fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# ax1b.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
#               behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
#               lw=2, alpha=0.8)
# ax1b.plot([0.5, 12.5], [0, 0], 'k--', lw=2)
# ax1b.set_xlim((0.5, 12.5))
# ax1b.set_ylim((-0.1, 0.15))
# #ax1b.tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# ax1b.set_xticks(range(1, 13))
# # ax1b.set_xticklabels(range(1, 13), size='large')
# ax1b.set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
# ax1b.set_xlabel('Serial Position', labelpad=1)
# ax1b.set_yticks([-0.1, 0.0, 0.1])
# ax1b.set_yticklabels([-0.1, 0.0, 0.1])
# ax1b.set_ylabel(r"$\Delta$"+'(p)', labelpad=1)
# sns.despine(offset=0, trim=True, ax=ax1b)
# # sns.despine(offset=0, ax=ax1b)
# ax1b.xaxis.set_tick_params(pad=3)
# ax1b.yaxis.set_tick_params(pad=3)

# ax2 = plt.subplot(gs[:, 1])
# sns.stripplot(data=[irts_within, irts_between], jitter=0.3,
#               alpha=0.3, ax=ax2, color='black')
# # sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# sns.pointplot(data=[irts_within, irts_between], ax=ax2, color='black', markers=['_', '_'])
# #ax.set_xlim((-0.175,1.175))
# ax2.set_xlim((-0.2,1.2))
# ax2.set_ylim((0, 8.5))
# ax2.set_yticks(np.arange(1, 9, 1))
# #sns.despine(offset=0, trim=True, ax=ax2)
# sns.despine(offset=0, ax=ax2)
# ax2.set_xticklabels(['within', 'between'])
# ax2.set_xlabel('Transition Type')
# ax2.set_ylabel('Inter-recall Time (s)')

# ax3 = plt.subplot(gs[:, 2])
# sns.stripplot(data=[behavioral_indices['catFR1']['ratio_of_rep'],
#                     behavioral_indices['FR1']['ratio_of_rep']], jitter=0.3,
#               alpha=0.3, ax=ax3, color='black')
# # sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# sns.pointplot(data=[behavioral_indices['catFR1']['ratio_of_rep'],
#                     behavioral_indices['FR1']['ratio_of_rep']], ax=ax3,
#               color='black', markers=['_', '_'])
# #ax.set_xlim((-0.175,1.175))
# ax3.set_xlim((-0.2,1.2))
# #sns.despine(offset=0, trim=True, ax=ax3)
# sns.despine(offset=0, ax=ax3)
# ax3.set_xticklabels(['categorized', 'unrelated'])
# ax3.set_ylabel('Ratio of Repetition')
# ax3.set_xlabel('List Type')
# ax3.set_ylim((0, 0.75))
# ax3.set_yticks(np.arange(0.1, 0.8, 0.1))

# ax4 = plt.subplot(gs[:, 3], aspect='equal')
# # ax4 = plt.subplot2grid((1, 4), (0, 2), colspan=2, aspect='equal')
# ax4 = sns.regplot(x=(behavioral_indices['catFR1']['ratio_of_rep']-
#                         behavioral_indices['FR1']['ratio_of_rep']),
#                      y=(behavioral_indices['catFR1']['recalled']-
#                         behavioral_indices['FR1']['recalled']),
#                   color='k', ci=95, ax=ax4,
#                   scatter_kws={'alpha': 0.3, 's': 20, 'edgecolors': 'none'})
# ax4.set_xlabel(r'$\Delta$(ratio of repetition)', labelpad=1)
# ax4.set_ylabel(r'$\Delta$p(recall)', labelpad=1)
# ax4.set_yticks(np.arange(-0.1, 0.4, 0.1))
# ax4.set_xticks(np.arange(0, 0.5, 0.1))
# sns.despine(offset=0, ax=ax4)
# # fig.subplots_adjust(left=0.08, bottom=0.24,
# #                     right=0.995, top=0.99, wspace=0.5 , hspace=0.15)
# fig.subplots_adjust(left=0.08, bottom=0.24,
#                     right=0.995, top=0.99, wspace=0.6 , hspace=0.15)
# plt.savefig('./figures/pub/FRcatFR_SPC_IRT_RR.pdf')



# fig = plt.figure(figsize=(6.92912, 1.9))
# gs = gridspec.GridSpec(nrows=2, ncols=4, height_ratios=[3, 1], width_ratios=[5, 5, 5, 7])
# ax1 = plt.subplot(gs[0, 0])
# ax1.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
#                    behdat['SPC']['CI95']['catFR1'], fmt='b-', lw=2, alpha=0.8,
#                    label='C')
# ax1.errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
#                    behdat['SPC']['CI95']['FR1'], fmt='g--', lw=2, alpha=0.8,
#                    label='U')
# ax1.set_xlim((0.5, 12.5))
# ax1.set_ylim((0, 0.65))
# ax1.set_yticks(np.arange(0, 0.7, 0.2))
# ax1.set_ylim((0., 0.65))
# ax1.set_ylabel('p(recall)')#, size='large')
# ax1.xaxis.set_visible(False)
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# # handles, labels = axs[0, 0].get_legend_handles_labels()
# # handles = [h[0] for h in handles]
# # axs[0, 0].legend(handles, labels, loc='upper right',
# #                  frameon=False, borderpad=0)
# sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=ax1)
# # sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# #axs[0, 0].xaxis.set_tick_params(pad=3)
# ax1.yaxis.set_tick_params(pad=3)
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = ax1.get_legend_handles_labels()
# handles = [h[0] for h in handles]
# ax1.legend(handles, labels, loc='upper right',
#            frameon=False, borderpad=0)

# ax1b = plt.subplot(gs[1, 0])
# # fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# ax1b.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
#               behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
#               lw=2, alpha=0.8)
# ax1b.plot([0.5, 12.5], [0, 0], 'k--', lw=2)
# ax1b.set_xlim((0.5, 12.5))
# ax1b.set_ylim((-0.1, 0.15))
# #ax1b.tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# ax1b.set_xticks(range(1, 13))
# # ax1b.set_xticklabels(range(1, 13), size='large')
# ax1b.set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
# ax1b.set_xlabel('Serial Position', labelpad=1)
# ax1b.set_yticks([-0.1, 0.0, 0.1])
# ax1b.set_yticklabels([-0.1, 0.0, 0.1])
# ax1b.set_ylabel(r"$\Delta$"+'(p)', labelpad=1)
# sns.despine(offset=0, trim=True, ax=ax1b)
# # sns.despine(offset=0, ax=ax1b)
# ax1b.xaxis.set_tick_params(pad=3)
# ax1b.yaxis.set_tick_params(pad=3)

# ax2 = plt.subplot(gs[:, 1])
# sns.violinplot(data=[irts_within, irts_between], cut=1.0, width=0.4, inner=None, 
# #            ax=ax2, color='black')
#             alpha=0.3, ax=ax2, color='gray')
# # sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# sns.pointplot(data=[irts_within, irts_between], ax=ax2, color='black', markers=['_', '_'])
# #ax.set_xlim((-0.175,1.175))
# ax2.set_xlim((-0.25,1.22))
# ax2.set_ylim((0, 8.5))
# ax2.set_yticks(np.arange(1, 9, 1))
# #sns.despine(offset=0, trim=True, ax=ax2)
# sns.despine(offset=0, ax=ax2)
# ax2.set_xticklabels(['within', 'between'])
# ax2.set_xlabel('Transition Type')
# ax2.set_ylabel('Inter-recall Time (s)')

# ax3 = plt.subplot(gs[:, 2])
# sns.violinplot(data=[behavioral_indices['catFR1']['ratio_of_rep'],
#                      behavioral_indices['FR1']['ratio_of_rep']], cut=1.0, width=0.4, inner=None, 
# #               ax=ax3, color='black')
#             alpha=0.3, ax=ax3, color='gray')
# # sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# sns.pointplot(data=[behavioral_indices['catFR1']['ratio_of_rep'],
#                     behavioral_indices['FR1']['ratio_of_rep']], ax=ax3,
#               color='black', markers=['_', '_'])
# #ax.set_xlim((-0.175,1.175))
# ax3.set_xlim((-0.25,1.22))
# #sns.despine(offset=0, trim=True, ax=ax3)
# sns.despine(offset=0, ax=ax3)
# ax3.set_xticklabels(['categorized', 'unrelated'])
# ax3.set_ylabel('Ratio of Repetition')
# ax3.set_xlabel('List Type')
# ax3.set_ylim((0, 0.77))
# ax3.set_yticks(np.arange(0.1, 0.8, 0.1))

# ax4 = plt.subplot(gs[:, 3], aspect='equal')
# # ax4 = plt.subplot2grid((1, 4), (0, 2), colspan=2, aspect='equal')
# ax4 = sns.regplot(x=(behavioral_indices['catFR1']['ratio_of_rep']-
#                         behavioral_indices['FR1']['ratio_of_rep']),
#                      y=(behavioral_indices['catFR1']['recalled']-
#                         behavioral_indices['FR1']['recalled']),
#                   color='k', ci=95, ax=ax4,
#                   scatter_kws={'alpha': 0.3, 's': 20, 'edgecolors': 'none'})
# ax4.set_xlabel(r'$\Delta$(ratio of repetition)', labelpad=1)
# ax4.set_ylabel(r'$\Delta$p(recall)', labelpad=1)
# ax4.set_yticks(np.arange(-0.1, 0.4, 0.1))
# ax4.set_xticks(np.arange(0, 0.5, 0.1))
# sns.despine(offset=0, ax=ax4)
# # fig.subplots_adjust(left=0.08, bottom=0.24,
# #                     right=0.995, top=0.99, wspace=0.5 , hspace=0.15)
# fig.subplots_adjust(left=0.08, bottom=0.24,
#                     right=0.995, top=0.99, wspace=0.6 , hspace=0.15)
# plt.savefig('./figures/pub/FRcatFR_SPC_IRT_RR.pdf')






# fig = plt.figure(figsize=(6.92912, 1.9))
# gs = gridspec.GridSpec(nrows=2, ncols=4, height_ratios=[3, 1], width_ratios=[5, 5, 5, 7])
# ax1 = plt.subplot(gs[0, 0])
# # ax1.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
# #                    behdat['SPC']['CI95']['FR1'], fmt='b-', lw=2, alpha=0.8,
# #                    label='C')
# # ax1.errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
# #                    behdat['SPC']['CI95']['FR1'], fmt='g--', lw=2, alpha=0.8,
# #                    label='U')
# ax1.plot(range(1, 13), behdat['SPC']['mean']['catFR1'], 'b-',
#          lw=2, alpha=0.8, label='C', solid_capstyle='butt')
# ax1.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['catFR1']+behdat['SPC']['CI95']['catFR1'],
#     behdat['SPC']['mean']['catFR1']-behdat['SPC']['CI95']['catFR1'],
#     facecolor='b', alpha=0.33, lw=0)
# # ax1.plot(range(1, 13), behdat['SPC']['mean']['FR1'], 'g--',
# ax1.plot(range(1, 13), behdat['SPC']['mean']['FR1'], 'y--',
#          lw=2, alpha=0.8, label='U')
# ax1.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['FR1']+behdat['SPC']['CI95']['FR1'],
#     behdat['SPC']['mean']['FR1']-behdat['SPC']['CI95']['FR1'],
#     facecolor='y', alpha=0.33, lw=0)
#     # facecolor='g', alpha=0.33, lw=0)
# ax1.set_xlim((0.5, 12.5))
# ax1.set_ylim((0, 0.65))
# ax1.set_yticks(np.arange(0, 0.7, 0.2))
# ax1.set_ylim((0., 0.65))
# ax1.set_ylabel('p(recall)')#, size='large')
# ax1.xaxis.set_visible(False)
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# # handles, labels = axs[0, 0].get_legend_handles_labels()
# # handles = [h[0] for h in handles]
# # axs[0, 0].legend(handles, labels, loc='upper right',
# #                  frameon=False, borderpad=0)
# #sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=ax1)
# sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# # sns.despine(offset=0, ax=ax1)
# # sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# #axs[0, 0].xaxis.set_tick_params(pad=3)
# ax1.yaxis.set_tick_params(pad=3)
# # # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# # handles, labels = ax1.get_legend_handles_labels()
# # handles = [h[0] for h in handles]
# # ax1.legend(handles, labels, loc='upper right',
# #            frameon=False, borderpad=0)
# ax1.legend(loc='upper right',
#            frameon=False, borderpad=0)

# ax1b = plt.subplot(gs[1, 0])
# # fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# # ax1b.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
# #               behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
# #               lw=2, alpha=0.8)
# # ax1b.plot(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'], 'k-',
# ax1b.plot(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'], 'g-',
#           lw=2, alpha=0.8, solid_capstyle='butt')
# ax1b.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['catFR1-FR1']+behdat['SPC']['CI95']['catFR1-FR1'],
#     behdat['SPC']['mean']['catFR1-FR1']-behdat['SPC']['CI95']['catFR1-FR1'],
#     facecolor='g', lw=2, alpha=0.33)
#     # facecolor='k', lw=2, alpha=0.33)
# # ax1b.plot([0.5, 12.5], [0, 0], 'k-', lw=1)
# ax1b.set_xlim((0.5, 12.5))
# ax1b.set_ylim((0, 0.15))
# #ax1b.tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# ax1b.set_xticks(range(1, 13))
# # ax1b.set_xticklabels(range(1, 13), size='large')
# ax1b.set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
# ax1b.set_xlabel('Serial Position', labelpad=1)
# ax1b.set_yticks([0.0, 0.1])
# ax1b.set_yticklabels([0.0, 0.1])
# ax1b.set_ylabel(r"$\Delta$"+'(p)', labelpad=1)
# # sns.despine(offset=0, trim=True, ax=ax1b)
# # sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=False, ax=ax1b)
# sns.despine(offset=0, ax=ax1b)
# # sns.despine(offset=0, ax=ax1b)
# ax1b.xaxis.set_tick_params(pad=3)
# ax1b.yaxis.set_tick_params(pad=3)

# ax2 = plt.subplot(gs[:, 1])
# sns.violinplot(data=[irts_within, irts_between], cut=1.0, width=0.4, inner=None, 
# #            ax=ax2, color='black')
#             alpha=0.3, ax=ax2, color='blue')
# #             alpha=0.3, ax=ax2, color='gray')
# # sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# # sns.pointplot(data=[irts_within, irts_between], ax=ax2,
# #               color='black', markers=['o', 'o'], linestyles='',
# #               # capsize=0.08,
# #               errwidth=2., scale = 0.4)
# irts = [irts_within, irts_between]
# irt_means = [irt.mean() for irt in irts]
# irt_SEs = [np.std(irt, ddof=1) / np.sqrt(len(irt)) for irt in irts]
# irt_CI95s = [se * dists.t.ppf(0.975, len(irt)-1) for se, irt in zip(irt_SEs, irts)]  
# ax2.errorbar(x=[0, 1], y=irt_means, yerr=irt_CI95s, marker='o', ecolor='black',
#              elinewidth=2, mfc='white', mec='black', linestyle='', ms=4)
# #ax.set_xlim((-0.175,1.175))
# ax2.set_xlim((-0.25,1.22))
# ax2.set_ylim((0, 8.5))
# ax2.set_yticks(np.arange(1, 9, 1))
# #sns.despine(offset=0, trim=True, ax=ax2)
# sns.despine(offset=0, ax=ax2)
# ax2.set_xticklabels(['within', 'between'])
# ax2.set_xlabel('Transition Type')
# ax2.set_ylabel('Inter-recall Time (s)')

# ax3 = plt.subplot(gs[:, 2])
# sns.violinplot(data=[behavioral_indices['catFR1']['arc'],
#                      behavioral_indices['FR1']['arc']], cut=1.0, width=0.4, inner=None, 
# #               ax=ax3, color='black')
#                alpha=0.3, ax=ax3, palette=['blue', 'yellow'])
#             # alpha=0.3, ax=ax3, color='gray')
# # sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# # sns.pointplot(data=[behavioral_indices['catFR1']['arc'],
# #                     behavioral_indices['FR1']['arc']], ax=ax3,
# #               color='black', markers=['o', 'o'], linestyles='',
# #               # capsize=0.08,
# #               errwidth=2., scale=0.4)
# arcs = [behavioral_indices['catFR1']['arc'], behavioral_indices['FR1']['arc']]
# arc_means = [arc.mean() for arc in arcs]
# arc_SEs = [np.std(arc, ddof=1) / np.sqrt(len(arc)) for arc in arcs]
# arc_CI95s = [se * dists.t.ppf(0.975, len(arc)-1) for se, irt in zip(arc_SEs, arcs)]  
# ax3.errorbar(x=[0, 1], y=arc_means, yerr=arc_CI95s, marker='o', ecolor='black',
#              elinewidth=2, mfc='white', mec='black', linestyle='', ms=4)
# #ax.set_xlim((-0.175,1.175))
# ax3.set_xlim((-0.25,1.22))
# #sns.despine(offset=0, trim=True, ax=ax3)
# sns.despine(offset=0, ax=ax3)
# ax3.set_xticklabels(['categorized', 'unrelated'])
# ax3.set_ylabel('ARC')
# ax3.set_xlabel('List Type')
# ax3.set_ylim((-0.25, 1.1))
# ax3.set_yticks(np.arange(0, 1.1, 0.5))

# ax4 = plt.subplot(gs[:, 3]) #, aspect='equal')
# # ax4 = plt.subplot2grid((1, 4), (0, 2), colspan=2, aspect='equal')
# ax4 = sns.regplot(x=(behavioral_indices['catFR1']['arc']-
#                         behavioral_indices['FR1']['arc']),
#                      y=(behavioral_indices['catFR1']['recalled']-
#                         behavioral_indices['FR1']['recalled']),
#                   color='k', ci=95, ax=ax4,
#                   scatter_kws={'alpha': 0.3, 's': 20, 'edgecolors': 'none'})
# ax4.set_xlabel(r'$\Delta$(ARC)', labelpad=1)
# ax4.set_ylabel(r'$\Delta$p(recall)', labelpad=1)
# ax4.set_xlim((-0.5, 0.9))
# ax4.set_ylim((-0.15, 0.36))
# ax4.set_yticks(np.arange(-0.1, 0.4, 0.1))
# ax4.set_xticks(np.arange(-0.4, 0.9, 0.4))
# sns.despine(offset=0, ax=ax4)
# # fig.subplots_adjust(left=0.08, bottom=0.24,
# #                     right=0.995, top=0.99, wspace=0.5 , hspace=0.15)
# fig.subplots_adjust(left=0.08, bottom=0.24,
#                     right=0.995, top=0.99, wspace=0.6 , hspace=0.15)
# plt.savefig('./figures/pub/FRcatFR_SPC_IRT_RR.pdf')









# fig = plt.figure(figsize=(6.92912, 1.9))
# gs = gridspec.GridSpec(nrows=2, ncols=4, height_ratios=[3, 1], width_ratios=[5, 5, 5, 7])
# ax1 = plt.subplot(gs[0, 0])
# # ax1.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
# #                    behdat['SPC']['CI95']['FR1'], fmt='b-', lw=2, alpha=0.8,
# #                    label='C')
# # ax1.errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
# #                    behdat['SPC']['CI95']['FR1'], fmt='g--', lw=2, alpha=0.8,
# #                    label='U')
# ax1.plot(range(1, 13), behdat['SPC']['mean']['catFR1'], 'b-',
#          lw=2, alpha=0.8, label='C', solid_capstyle='butt')
# ax1.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['catFR1']+behdat['SPC']['CI95']['catFR1'],
#     behdat['SPC']['mean']['catFR1']-behdat['SPC']['CI95']['catFR1'],
#     facecolor='b', alpha=0.33, lw=0)
# ax1.plot(range(1, 13), behdat['SPC']['mean']['FR1'], 'g--',
#          lw=2, alpha=0.8, label='U')
# ax1.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['FR1']+behdat['SPC']['CI95']['FR1'],
#     behdat['SPC']['mean']['FR1']-behdat['SPC']['CI95']['FR1'],
#     facecolor='g', alpha=0.33, lw=0)
# ax1.set_xlim((0.5, 12.5))
# ax1.set_ylim((0, 0.65))
# ax1.set_yticks(np.arange(0, 0.7, 0.2))
# ax1.set_ylim((0., 0.65))
# ax1.set_ylabel('p(recall)')#, size='large')
# ax1.xaxis.set_visible(False)
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# # handles, labels = axs[0, 0].get_legend_handles_labels()
# # handles = [h[0] for h in handles]
# # axs[0, 0].legend(handles, labels, loc='upper right',
# #                  frameon=False, borderpad=0)
# #sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=ax1)
# sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# # sns.despine(offset=0, ax=ax1)
# # sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# #axs[0, 0].xaxis.set_tick_params(pad=3)
# ax1.yaxis.set_tick_params(pad=3)
# # # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# # handles, labels = ax1.get_legend_handles_labels()
# # handles = [h[0] for h in handles]
# # ax1.legend(handles, labels, loc='upper right',
# #            frameon=False, borderpad=0)
# ax1.legend(loc='upper right',
#            frameon=False, borderpad=0)

# ax1b = plt.subplot(gs[1, 0])
# # fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# # ax1b.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
# #               behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
# #               lw=2, alpha=0.8)
# ax1b.plot(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'], 'k-',
#           lw=2, alpha=0.8, solid_capstyle='butt')
# ax1b.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['catFR1-FR1']+behdat['SPC']['CI95']['catFR1-FR1'],
#     behdat['SPC']['mean']['catFR1-FR1']-behdat['SPC']['CI95']['catFR1-FR1'],
#     facecolor='k', lw=2, alpha=0.33)
# # ax1b.plot([0.5, 12.5], [0, 0], 'k-', lw=1)
# ax1b.set_xlim((0.5, 12.5))
# ax1b.set_ylim((0, 0.15))
# #ax1b.tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# ax1b.set_xticks(range(1, 13))
# # ax1b.set_xticklabels(range(1, 13), size='large')
# ax1b.set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
# ax1b.set_xlabel('Serial Position', labelpad=1)
# ax1b.set_yticks([0.0, 0.1])
# ax1b.set_yticklabels([0.0, 0.1])
# ax1b.set_ylabel(r"$\Delta$"+'(p)', labelpad=1)
# # sns.despine(offset=0, trim=True, ax=ax1b)
# # sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=False, ax=ax1b)
# sns.despine(offset=0, ax=ax1b)
# # sns.despine(offset=0, ax=ax1b)
# ax1b.xaxis.set_tick_params(pad=3)
# ax1b.yaxis.set_tick_params(pad=3)

# ax2 = plt.subplot(gs[:, 1])
# positions = [0, 1]
# parts = ax2.violinplot(dataset=[irts_within, irts_between], showextrema=False,
#                        positions=positions, widths=0.3)
# for i, pc in enumerate(parts['bodies']):
#     pc.set_edgecolor('black')
#     pc.set_alpha('0.5')
#     pc.set_linewidth(2)
#     pc.set_facecolor('dimgray')
# irts = [irts_within, irts_between]
# irt_means = [irt.mean() for irt in irts]
# irt_SEs = [np.std(irt, ddof=1) / np.sqrt(len(irt)) for irt in irts]
# irt_CI95s = [se * dists.t.ppf(0.975, len(irt)-1) for se, irt in zip(irt_SEs, irts)]  
# ax2.errorbar(x=[0, 1], y=irt_means, yerr=irt_CI95s, marker='o', ecolor='black',
#              elinewidth=2, mfc='white', mec='black', linestyle='', ms=4)
# #ax.set_xlim((-0.175,1.175))
# ax2.set_xlim((-0.25,1.22))
# ax2.set_ylim((0, 8.5))
# ax2.set_yticks(np.arange(1, 9, 1))
# #sns.despine(offset=0, trim=True, ax=ax2)
# sns.despine(offset=0, ax=ax2)
# ax2.set_xticks(positions)
# ax2.set_xticklabels(['within', 'between'])
# ax2.set_xlabel('Transition Type')
# ax2.set_ylabel('Inter-recall Time (s)')

# ax3 = plt.subplot(gs[:, 2])
# positions = [0, 1]
# parts = ax3.violinplot(dataset=[behavioral_indices['catFR1']['arc'],
#                                 behavioral_indices['FR1']['arc']],
#                        showextrema=False, positions=positions, widths=0.3)
# for i, pc in enumerate(parts['bodies']):
#     pc.set_edgecolor('black')
#     pc.set_alpha('0.5')
#     pc.set_linewidth(2)
#     pc.set_facecolor('dimgray')
# # sns.violinplot(data=[behavioral_indices['catFR1']['arc'],
# #                      behavioral_indices['FR1']['arc']], cut=1.0, width=0.4, inner=None, 
# # #               ax=ax3, color='black')
# #                alpha=0.3, ax=ax3, palette=['blue', 'yellow'])
# #             # alpha=0.3, ax=ax3, color='gray')
# # sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# # sns.pointplot(data=[behavioral_indices['catFR1']['arc'],
# #                     behavioral_indices['FR1']['arc']], ax=ax3,
# #               color='black', markers=['o', 'o'], linestyles='',
# #               # capsize=0.08,
# #               errwidth=2., scale=0.4)
# arcs = [behavioral_indices['catFR1']['arc'], behavioral_indices['FR1']['arc']]
# arc_means = [arc.mean() for arc in arcs]
# arc_SEs = [np.std(arc, ddof=1) / np.sqrt(len(arc)) for arc in arcs]
# arc_CI95s = [se * dists.t.ppf(0.975, len(arc)-1) for se, irt in zip(arc_SEs, arcs)]  
# ax3.errorbar(x=[0, 1], y=arc_means, yerr=arc_CI95s, marker='o', ecolor='black',
#              elinewidth=2, mfc='white', mec='black', linestyle='', ms=4)
# #ax.set_xlim((-0.175,1.175))
# ax3.set_xlim((-0.25,1.22))
# # ax3.set_xlim((-0.25, 2))
# #sns.despine(offset=0, trim=True, ax=ax3)
# sns.despine(offset=0, ax=ax3)
# ax3.set_xticks(positions)
# ax3.set_xticklabels(['categorized', 'unrelated'])
# ax3.set_ylabel('Clustering (ARC)')#, labelpad=1)
# ax3.set_xlabel('List Type')
# ax3.set_ylim((-0.25, 1.1))
# ax3.set_yticks(np.arange(0, 1.1, 0.5))

# ax4 = plt.subplot(gs[:, 3]) #, aspect='equal')
# # ax4 = plt.subplot2grid((1, 4), (0, 2), colspan=2, aspect='equal')
# ax4 = sns.regplot(x=(behavioral_indices['catFR1']['arc']-
#                         behavioral_indices['FR1']['arc']),
#                      y=(behavioral_indices['catFR1']['recalled']-
#                         behavioral_indices['FR1']['recalled']),
#                   color='k', ci=95, ax=ax4,
#                   scatter_kws={'alpha': 0.3, 's': 20, 'edgecolors': 'none'})
# ax4.set_xlabel(r'$\Delta$(ARC)', labelpad=1)
# ax4.set_ylabel(r'$\Delta$p(recall)', labelpad=-5)
# ax4.set_xlim((-0.5, 0.9))
# ax4.set_ylim((-0.15, 0.36))
# ax4.set_yticks(np.arange(-0.1, 0.4, 0.1))
# ax4.set_xticks(np.arange(-0.4, 0.9, 0.4))
# sns.despine(offset=0, ax=ax4)
# # fig.subplots_adjust(left=0.08, bottom=0.24,
# #                     right=0.995, top=0.99, wspace=0.5 , hspace=0.15)
# #fig.subplots_adjust(left=0.08, bottom=0.24,
# #                     right=0.995, top=0.99, wspace=0.6 , hspace=0.1)
# fig.subplots_adjust(left=0.075, bottom=0.24,
#                     right=0.995, top=0.99, wspace=0.55, hspace=0.15)
# plt.savefig('./figures/pub/FRcatFR_SPC_IRT_RR.pdf')




# fig = plt.figure(figsize=(6.92912, 1.9))
# gs = gridspec.GridSpec(nrows=2, ncols=4, height_ratios=[3, 1], width_ratios=[5, 5, 5, 7])
# ax1 = plt.subplot(gs[0, 0])
# # ax1.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
# #                    behdat['SPC']['CI95']['FR1'], fmt='b-', lw=2, alpha=0.8,
# #                    label='C')
# # ax1.errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
# #                    behdat['SPC']['CI95']['FR1'], fmt='g--', lw=2, alpha=0.8,
# #                    label='U')
# ax1.plot(range(1, 13), behdat['SPC']['mean']['catFR1'], 'b-',
#          lw=2, alpha=0.8, label='C', solid_capstyle='butt')
# ax1.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['catFR1']+behdat['SPC']['CI95']['catFR1'],
#     behdat['SPC']['mean']['catFR1']-behdat['SPC']['CI95']['catFR1'],
#     facecolor='b', alpha=0.33, lw=0)
# ax1.plot(range(1, 13), behdat['SPC']['mean']['FR1'], 'g--',
#          lw=2, alpha=0.8, label='U')
# ax1.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['FR1']+behdat['SPC']['CI95']['FR1'],
#     behdat['SPC']['mean']['FR1']-behdat['SPC']['CI95']['FR1'],
#     facecolor='g', alpha=0.33, lw=0)
# ax1.set_xlim((0.5, 12.5))
# ax1.set_ylim((0, 0.65))
# ax1.set_yticks(np.arange(0, 0.7, 0.2))
# ax1.set_ylim((0., 0.65))
# ax1.set_ylabel('p(recall)')#, size='large')
# ax1.xaxis.set_visible(False)
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# # handles, labels = axs[0, 0].get_legend_handles_labels()
# # handles = [h[0] for h in handles]
# # axs[0, 0].legend(handles, labels, loc='upper right',
# #                  frameon=False, borderpad=0)
# #sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=ax1)
# sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# # sns.despine(offset=0, ax=ax1)
# # sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# #axs[0, 0].xaxis.set_tick_params(pad=3)
# ax1.yaxis.set_tick_params(pad=3)
# # # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# # handles, labels = ax1.get_legend_handles_labels()
# # handles = [h[0] for h in handles]
# # ax1.legend(handles, labels, loc='upper right',
# #            frameon=False, borderpad=0)
# ax1.legend(loc='upper right',
#            frameon=False, borderpad=0)

# ax1b = plt.subplot(gs[1, 0])
# # fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# # ax1b.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
# #               behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
# #               lw=2, alpha=0.8)
# ax1b.plot(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'], 'k-',
#           lw=2, alpha=0.8, solid_capstyle='butt')
# ax1b.fill_between(
#     range(1, 13),
#     behdat['SPC']['mean']['catFR1-FR1']+behdat['SPC']['CI95']['catFR1-FR1'],
#     behdat['SPC']['mean']['catFR1-FR1']-behdat['SPC']['CI95']['catFR1-FR1'],
#     facecolor='k', lw=2, alpha=0.33)
# # ax1b.plot([0.5, 12.5], [0, 0], 'k-', lw=1)
# ax1b.set_xlim((0.5, 12.5))
# ax1b.set_ylim((0, 0.15))
# #ax1b.tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# ax1b.set_xticks(range(1, 13))
# # ax1b.set_xticklabels(range(1, 13), size='large')
# ax1b.set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
# ax1b.set_xlabel('Serial Position', labelpad=1)
# ax1b.set_yticks([0.0, 0.1])
# ax1b.set_yticklabels([0.0, 0.1])
# ax1b.set_ylabel(r"$\Delta$"+'(p)', labelpad=1)
# # sns.despine(offset=0, trim=True, ax=ax1b)
# # sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=False, ax=ax1b)
# sns.despine(offset=0, ax=ax1b)
# # sns.despine(offset=0, ax=ax1b)
# ax1b.xaxis.set_tick_params(pad=3)
# ax1b.yaxis.set_tick_params(pad=3)

# ax2 = plt.subplot(gs[:, 1])
# positions = [0, 1]
# parts = ax2.violinplot(dataset=[irts_within, irts_between], showextrema=False,
#                        positions=positions, widths=0.3)
# for i, pc in enumerate(parts['bodies']):
#     pc.set_edgecolor('black')
#     pc.set_alpha('0.5')
#     pc.set_linewidth(2)
#     pc.set_facecolor('dimgray')
# irts = [irts_within, irts_between]
# irt_means = [irt.mean() for irt in irts]
# irt_SEs = [np.std(irt, ddof=1) / np.sqrt(len(irt)) for irt in irts]
# irt_CI95s = [se * dists.t.ppf(0.975, len(irt)-1) for se, irt in zip(irt_SEs, irts)]  
# ax2.errorbar(x=[0, 1], y=irt_means, yerr=irt_CI95s, marker='', ecolor='black',
#              elinewidth=2, mfc='white', mec='black', linestyle='', ms=4)
# #ax.set_xlim((-0.175,1.175))
# ax2.set_xlim((-0.25,1.22))
# ax2.set_ylim((0, 8.5))
# ax2.set_yticks(np.arange(1, 9, 1))
# #sns.despine(offset=0, trim=True, ax=ax2)
# sns.despine(offset=0, ax=ax2)
# ax2.set_xticks(positions)
# ax2.set_xticklabels(['within', 'between'])
# ax2.set_xlabel('Transition Type')
# ax2.set_ylabel('Inter-recall Time (s)')

# ax3 = plt.subplot(gs[:, 2])
# positions = [0, 1]
# parts = ax3.violinplot(dataset=[behavioral_indices['catFR1']['arc'],
#                                 behavioral_indices['FR1']['arc']],
#                        showextrema=False, positions=positions, widths=0.3)
# for i, pc in enumerate(parts['bodies']):
#     pc.set_edgecolor('black')
#     pc.set_alpha('0.5')
#     pc.set_linewidth(2)
#     pc.set_facecolor('dimgray')
# # sns.violinplot(data=[behavioral_indices['catFR1']['arc'],
# #                      behavioral_indices['FR1']['arc']], cut=1.0, width=0.4, inner=None, 
# # #               ax=ax3, color='black')
# #                alpha=0.3, ax=ax3, palette=['blue', 'yellow'])
# #             # alpha=0.3, ax=ax3, color='gray')
# # sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# # sns.pointplot(data=[behavioral_indices['catFR1']['arc'],
# #                     behavioral_indices['FR1']['arc']], ax=ax3,
# #               color='black', markers=['o', 'o'], linestyles='',
# #               # capsize=0.08,
# #               errwidth=2., scale=0.4)
# arcs = [behavioral_indices['catFR1']['arc'], behavioral_indices['FR1']['arc']]
# arc_means = [arc.mean() for arc in arcs]
# arc_SEs = [np.std(arc, ddof=1) / np.sqrt(len(arc)) for arc in arcs]
# arc_CI95s = [se * dists.t.ppf(0.975, len(arc)-1) for se, irt in zip(arc_SEs, arcs)]  
# ax3.errorbar(x=[0, 1], y=arc_means, yerr=arc_CI95s, marker='', ecolor='black',
#              elinewidth=2, mfc='white', mec='black', linestyle='', ms=4)
# #ax.set_xlim((-0.175,1.175))
# ax3.set_xlim((-0.25,1.22))
# # ax3.set_xlim((-0.25, 2))
# #sns.despine(offset=0, trim=True, ax=ax3)
# sns.despine(offset=0, ax=ax3)
# ax3.set_xticks(positions)
# ax3.set_xticklabels(['categorized', 'unrelated'])
# ax3.set_ylabel('Clustering (ARC)')#, labelpad=1)
# ax3.set_xlabel('List Type')
# ax3.set_ylim((-0.25, 1.1))
# ax3.set_yticks(np.arange(0, 1.1, 0.5))

# ax4 = plt.subplot(gs[:, 3]) #, aspect='equal')
# # ax4 = plt.subplot2grid((1, 4), (0, 2), colspan=2, aspect='equal')
# ax4 = sns.regplot(x=(behavioral_indices['catFR1']['arc']-
#                         behavioral_indices['FR1']['arc']),
#                      y=(behavioral_indices['catFR1']['recalled']-
#                         behavioral_indices['FR1']['recalled']),
#                   color='k', ci=95, ax=ax4,
#                   scatter_kws={'alpha': 0.3, 's': 20, 'edgecolors': 'none'})
# ax4.set_xlabel(r'$\Delta$(ARC)', labelpad=1)
# ax4.set_ylabel(r'$\Delta$p(recall)', labelpad=-5)
# ax4.set_xlim((-0.5, 0.9))
# ax4.set_ylim((-0.15, 0.36))
# ax4.set_yticks(np.arange(-0.1, 0.4, 0.1))
# ax4.set_xticks(np.arange(-0.4, 0.9, 0.4))
# sns.despine(offset=0, ax=ax4)
# # fig.subplots_adjust(left=0.08, bottom=0.24,
# #                     right=0.995, top=0.99, wspace=0.5 , hspace=0.15)
# #fig.subplots_adjust(left=0.08, bottom=0.24,
# #                     right=0.995, top=0.99, wspace=0.6 , hspace=0.1)
# fig.subplots_adjust(left=0.075, bottom=0.24,
#                     right=0.995, top=0.99, wspace=0.55, hspace=0.15)
# plt.savefig('./figures/pub/FRcatFR_SPC_IRT_RR_nodots.pdf')








fig = plt.figure(figsize=(6.92912, 1.9))
gs = gridspec.GridSpec(nrows=2, ncols=4, height_ratios=[3, 1], width_ratios=[5, 5, 5, 7])
ax1 = plt.subplot(gs[0, 0])
# ax1.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
#                    behdat['SPC']['CI95']['FR1'], fmt='b-', lw=2, alpha=0.8,
#                    label='C')
# ax1.errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
#                    behdat['SPC']['CI95']['FR1'], fmt='g--', lw=2, alpha=0.8,
#                    label='U')
# ax1.plot(range(1, 13), behdat['SPC']['mean']['catFR1'], 'k-', #'b-',
ax1.plot(range(1, 13), behdat['SPC']['mean']['catFR1'], 'b-',
         lw=2, alpha=0.8, label='C', solid_capstyle='butt')
ax1.fill_between(
    range(1, 13),
    behdat['SPC']['mean']['catFR1']+behdat['SPC']['CI95']['catFR1'],
    behdat['SPC']['mean']['catFR1']-behdat['SPC']['CI95']['catFR1'],
    # facecolor='k', alpha=0.33, lw=0)
    facecolor='b', alpha=0.33, lw=0)
# ax1.plot(range(1, 13), behdat['SPC']['mean']['FR1'], 'k--', #'g--',
ax1.plot(range(1, 13), behdat['SPC']['mean']['FR1'], 'g--',
         lw=2, alpha=0.8, label='U')
ax1.fill_between(
    range(1, 13),
    behdat['SPC']['mean']['FR1']+behdat['SPC']['CI95']['FR1'],
    behdat['SPC']['mean']['FR1']-behdat['SPC']['CI95']['FR1'],
    # facecolor='k', alpha=0.33, lw=0)
    facecolor='g', alpha=0.33, lw=0)
ax1.set_xlim((0.5, 12.5))
ax1.set_ylim((0, 0.65))
ax1.set_yticks(np.arange(0, 0.7, 0.2))
ax1.set_ylim((0., 0.65))
ax1.set_ylabel('p(recall)')#, size='large')
ax1.xaxis.set_visible(False)
# http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 0].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 0].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)
#sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=ax1)
sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
# sns.despine(offset=0, ax=ax1)
# sns.despine(offset=0, top=True, right=True, left=False, bottom=True, ax=ax1)
#axs[0, 0].xaxis.set_tick_params(pad=3)
ax1.yaxis.set_tick_params(pad=3)
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = ax1.get_legend_handles_labels()
# handles = [h[0] for h in handles]
# ax1.legend(handles, labels, loc='upper right',
#            frameon=False, borderpad=0)
ax1.legend(loc='upper right',
           frameon=False, borderpad=0)

ax1b = plt.subplot(gs[1, 0])
# fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# ax1b.errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
#               behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
#               lw=2, alpha=0.8)
ax1b.plot(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'], 'k-',
          lw=2, alpha=0.8, solid_capstyle='butt')
ax1b.fill_between(
    range(1, 13),
    behdat['SPC']['mean']['catFR1-FR1']+behdat['SPC']['CI95']['catFR1-FR1'],
    behdat['SPC']['mean']['catFR1-FR1']-behdat['SPC']['CI95']['catFR1-FR1'],
    facecolor='k', lw=2, alpha=0.33)
# ax1b.plot([0.5, 12.5], [0, 0], 'k-', lw=1)
ax1b.set_xlim((0.5, 12.5))
ax1b.set_ylim((0, 0.15))
#ax1b.tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
ax1b.set_xticks(range(1, 13))
# ax1b.set_xticklabels(range(1, 13), size='large')
ax1b.set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
ax1b.set_xlabel('Serial Position', labelpad=1)
ax1b.set_yticks([0.0, 0.1])
ax1b.set_yticklabels([0.0, 0.1])
ax1b.set_ylabel(r"$\Delta$"+'(p)', labelpad=1)
# sns.despine(offset=0, trim=True, ax=ax1b)
# sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=False, ax=ax1b)
sns.despine(offset=0, ax=ax1b)
# sns.despine(offset=0, ax=ax1b)
ax1b.xaxis.set_tick_params(pad=3)
ax1b.yaxis.set_tick_params(pad=3)

ax2 = plt.subplot(gs[:, 1])
positions = [0, 1]
parts = ax2.violinplot(dataset=[irts_within, irts_between], showextrema=False,
                       positions=positions, widths=0.3)
for i, pc in enumerate(parts['bodies']):
    pc.set_edgecolor('black')
    pc.set_alpha('0.5')
    pc.set_linewidth(2)
    pc.set_facecolor('dimgray')
irts = [irts_within, irts_between]
irt_means = [irt.mean() for irt in irts]
irt_SEs = [np.std(irt, ddof=1) / np.sqrt(len(irt)) for irt in irts]
irt_CI95s = [se * dists.t.ppf(0.975, len(irt)-1) for se, irt in zip(irt_SEs, irts)]  
ax2.errorbar(x=[0, 1], y=irt_means, yerr=irt_CI95s, marker='o', ecolor='black',
             elinewidth=2, mfc='white', mec='black', linestyle='', ms=2)
#ax.set_xlim((-0.175,1.175))
ax2.set_xlim((-0.25,1.22))
ax2.set_ylim((0, 8.5))
ax2.set_yticks(np.arange(1, 9, 1))
#sns.despine(offset=0, trim=True, ax=ax2)
sns.despine(offset=0, ax=ax2)
ax2.set_xticks(positions)
ax2.set_xticklabels(['within', 'between'])
ax2.set_xlabel('Transition Type')
ax2.set_ylabel('Inter-recall Time (s)')

ax3 = plt.subplot(gs[:, 2])
positions = [0, 1]
parts = ax3.violinplot(dataset=[behavioral_indices['catFR1']['arc'],
                                behavioral_indices['FR1']['arc']],
                       showextrema=False, positions=positions, widths=0.3)
# cols = ['blue', 'green']
for i, pc in enumerate(parts['bodies']):
    pc.set_edgecolor('black')
    pc.set_alpha('0.5')
    pc.set_linewidth(2)
    pc.set_facecolor('dimgray')
    # pc.set_facecolor(cols[i])
# sns.violinplot(data=[behavioral_indices['catFR1']['arc'],
#                      behavioral_indices['FR1']['arc']], cut=1.0, width=0.4, inner=None, 
# #               ax=ax3, color='black')
#                alpha=0.3, ax=ax3, palette=['blue', 'yellow'])
#             # alpha=0.3, ax=ax3, color='gray')
# sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
# sns.pointplot(data=[behavioral_indices['catFR1']['arc'],
#                     behavioral_indices['FR1']['arc']], ax=ax3,
#               color='black', markers=['o', 'o'], linestyles='',
#               # capsize=0.08,
#               errwidth=2., scale=0.4)
arcs = [behavioral_indices['catFR1']['arc'], behavioral_indices['FR1']['arc']]
arc_means = [arc.mean() for arc in arcs]
arc_SEs = [np.std(arc, ddof=1) / np.sqrt(len(arc)) for arc in arcs]
arc_CI95s = [se * dists.t.ppf(0.975, len(arc)-1) for se, irt in zip(arc_SEs, arcs)]  
ax3.errorbar(x=[0, 1], y=arc_means, yerr=arc_CI95s, marker='o', ecolor='black',
             elinewidth=2, mfc='white', mec='black', linestyle='', ms=2)
#ax.set_xlim((-0.175,1.175))
ax3.set_xlim((-0.25,1.22))
# ax3.set_xlim((-0.25, 2))
#sns.despine(offset=0, trim=True, ax=ax3)
sns.despine(offset=0, ax=ax3)
ax3.set_xticks(positions)
ax3.set_xticklabels(['categorized', 'unrelated'])
ax3.set_ylabel('Clustering (ARC)')#, labelpad=1)
ax3.set_xlabel('List Type')
ax3.set_ylim((-0.25, 1.1))
ax3.set_yticks(np.arange(0, 1.1, 0.5))

ax4 = plt.subplot(gs[:, 3]) #, aspect='equal')
# ax4 = plt.subplot2grid((1, 4), (0, 2), colspan=2, aspect='equal')
ax4 = sns.regplot(x=(behavioral_indices['catFR1']['arc']-
                        behavioral_indices['FR1']['arc']),
                     y=(behavioral_indices['catFR1']['recalled']-
                        behavioral_indices['FR1']['recalled']),
                  color='k', ci=95, ax=ax4,
                  scatter_kws={'alpha': 0.3, 's': 20, 'edgecolors': 'none'})
ax4.set_xlabel(r'$\Delta$(ARC)', labelpad=1)
ax4.set_ylabel(r'$\Delta$p(recall)', labelpad=-5)
ax4.set_xlim((-0.5, 0.9))
ax4.set_ylim((-0.15, 0.36))
ax4.set_yticks(np.arange(-0.1, 0.4, 0.1))
ax4.set_xticks(np.arange(-0.4, 0.9, 0.4))
sns.despine(offset=0, ax=ax4)
# fig.subplots_adjust(left=0.08, bottom=0.24,
#                     right=0.995, top=0.99, wspace=0.5 , hspace=0.15)
#fig.subplots_adjust(left=0.08, bottom=0.24,
#                     right=0.995, top=0.99, wspace=0.6 , hspace=0.1)
fig.subplots_adjust(left=0.075, bottom=0.24,
                    right=0.995, top=0.99, wspace=0.55, hspace=0.15)
plt.savefig('./figures/pub/FRcatFR_SPC_IRT_RR.pdf')


















from scipy.stats import ttest_rel
# differences between within and between irt
tval, pval = ttest_rel(irts_between, irts_within)
irt_diff = np.array(irts_between)-np.array(irts_within)
se = np.std(irt_diff, ddof=1)/np.sqrt(len(irt_diff))
df = len(irt_diff)-1
print 't=', tval, 'p=', pval, 'SE=', se, 'df=', df
# In [91]: t= 14.5444577986 p= 1.47497254122e-22 SE= 0.153762408615 df= 68

tval_match, pval_match = ttest_rel(irts_between_match, irts_within_match)
irt_diff_match = np.array(irts_between_match)-np.array(irts_within_match)
se_match = np.std(irt_diff_match, ddof=1)/np.sqrt(len(irt_diff_match))
df_match = len(irt_diff_match)-1
print 't=', tval_match, 'p=', pval_match, 'SE=', se_match, 'df=', df_match
# In [101]: t= 8.35687154733 p= 4.92846597083e-12 SE= 0.201316014344 df= 68



# differences between catFR and FR
tval, pval = ttest_rel(behavioral_indices['catFR1']['arc'],
                       behavioral_indices['FR1']['arc'])
rr_diff = behavioral_indices['catFR1']['arc']-behavioral_indices['FR1']['arc']
se = np.std(rr_diff, ddof=1)/np.sqrt(len(rr_diff))
df = len(rr_diff)-1
print 't=', tval, 'p=', pval, 'SE=', se, 'df=', df
# t= 10.0770984606 p= 3.98746560561e-15 SE= 0.0315800107516 df= 68


tval, pval = ttest_rel(behavioral_indices['catFR1']['arc_near'],
                       behavioral_indices['FR1']['arc_near'])
rr_diff = behavioral_indices['catFR1']['arc_near']-behavioral_indices['FR1']['arc_near']
se = np.std(rr_diff, ddof=1)/np.sqrt(len(rr_diff))
df = len(rr_diff)-1
print 't=', tval, 'p=', pval, 'SE=', se, 'df=', df
# t= 0.273361145633 p= 0.785404169221 SE= 0.0272042867287 df= 68


tval, pval = ttest_rel(behavioral_indices['catFR1']['arc_far'],
                behavioral_indices['FR1']['arc_far'])
rr_diff = behavioral_indices['catFR1']['arc_far']-behavioral_indices['FR1']['arc_far']
se = np.std(rr_diff, ddof=1)/np.sqrt(len(rr_diff))
df = len(rr_diff)-1
print 't=', tval, 'p=', pval, 'SE=', se, 'df=', df
# t= 6.02886459493 p= 7.5702738223e-08 SE= 0.032906795728 df= 68

# with stat
from scipy.stats import pearsonr
rval, pval = pearsonr(behavioral_indices['catFR1']['ratio_of_rep']-behavioral_indices['FR1']['ratio_of_rep'],
                      behavioral_indices['catFR1']['recalled']-behavioral_indices['FR1']['recalled'])
print 'r=', rval, 'p=', pval
# r= 0.556306082509 p= 6.94007612455e-07


























        
# fig, ax = plt.subplots(nrows=1, ncols=1, figsize=(1, 1))
#ax.plot(behavioral_indices['catFR1']['ratio_of_rep']-behavioral_indices['FR1']['ratio_of_rep'],
#        behavioral_indices['catFR1']['recalled']-behavioral_indices['FR1']['recalled'], 'ko', alpha=0.5)
grid = sns.jointplot(x=(behavioral_indices['catFR1']['ratio_of_rep']-
                        behavioral_indices['FR1']['ratio_of_rep']),
                     y=(behavioral_indices['catFR1']['recalled']-
                        behavioral_indices['FR1']['recalled']),
                     stat_func=None, color='k', kind='reg', ci=95, size=3.5)
grid.set_axis_labels(r'$\Delta$RR', r'$\Delta$p(recall)', labelpad=1, size='large')
#grid.fig.set_size_inches((4,4))
#grid.fig.set_size_inches((2,2))
grid.fig.axes[0].xaxis.set_tick_params(pad=3)
grid.fig.axes[0].yaxis.set_tick_params(pad=3)
grid.fig.axes[0].set_xticks(np.arange(0, 0.61, 0.1))
grid.fig.axes[0].set_xticklabels(np.arange(0, 0.61, 0.1), size='large')
grid.fig.axes[0].set_yticks(np.arange(-0.2, 0.41, 0.1))
grid.fig.axes[0].set_yticklabels(np.arange(-0.2, 0.41, 0.1), size='large')
grid.fig.axes[0].yaxis.set_tick_params(pad=3)
grid.fig.axes[0].set_xlim(-0.05, 0.475)
grid.fig.axes[0].set_ylim(-0.175, 0.35)



#grid.fig.subplots_adjust(left=0.3, right=0.9, bottom=0.3, top=0.9,
#                         wspace=0, hspace=0)
grid.savefig('./figures/pub/FRcatFR_deltaRR_deltaPrec_scatterplot.pdf')


# with stat
from scipy.stats import pearsonr
rval, pval = pearsonr(behavioral_indices['catFR1']['ratio_of_rep']-behavioral_indices['FR1']['ratio_of_rep'],
                      behavioral_indices['catFR1']['recalled']-behavioral_indices['FR1']['recalled'])
print 'r=', rval, 'p=', pval
# In [15]: r= 0.560839203355 p= 1.86373361736e-05
# In [17]: behavioral_indices['catFR1']['ratio_of_rep'].shape
# Out[17]: (51,)




# grid = sns.jointplot(x=(behavioral_indices['catFR1']['ratio_of_rep']-
#                         behavioral_indices['FR1']['ratio_of_rep']),
#                      y=(behavioral_indices['catFR1']['num_intrusions']-
#                         behavioral_indices['FR1']['num_intrusions']),
#                      stat_func=None, color='k', kind='reg', ci=95, size=3.5)
# grid = sns.jointplot(x=(behavioral_indices['catFR1']['ratio_of_rep']-
#                         behavioral_indices['FR1']['ratio_of_rep']),
#                      y=behavioral_indices['catFR1']['num_intrusions'],
#                      stat_func=None, color='k', kind='reg', ci=95, size=3.5)
# grid = sns.jointplot(x=behavioral_indices['catFR1']['ratio_of_rep'],
#                      y=behavioral_indices['catFR1']['num_intrusions'],
#                      stat_func=None, color='k', kind='reg', ci=95, size=3.5)
# grid.set_axis_labels(r'$\Delta$RR', r'$\Delta$ Intrusions', labelpad=1, size='large')






# for subj in np.unique(evs_bothexp_cluster['FR1']['subject']):
#     subjfilt = {exp: evs_bothexp_cluster[exp]['subject'] == subj
#                 for exp in evs_bothexp_cluster}
#     for bh in behavioral_indices:
#         behavioral_indices[bh].append([evs_bothexp_cluster[exp][
#             wordfilt[exp] & subjfilt[exp]][
#                 bh].mean() for exp in ['FR1', 'catFR1']])
        
#     # behavioral_indices['num_rec'].append([evs_bothexp_cluster[exp][
#     #     wordfilt[exp] & subjfilt[exp]][
#     #         'num_rec'].mean() for exp in ['FR1', 'catFR1']])

#     # print subj
# ratios_of_rep = np.array(ratios_of_rep)        


fig, axs = plt.subplots(nrows=1, ncols=1, figsize=(2, 2))
se_rr = {exp: np.std(behavioral_indices[exp]['ratio_of_rep']) / np.sqrt(
    len(behavioral_indices[exp]['ratio_of_rep'])) for exp in ['catFR1', 'FR1']}
ci95_rr = {exp: stats.t.ppf(
    0.975, len(behavioral_indices[exp]['ratio_of_rep'])-1)*se_rr[exp]
           for exp in ['catFR1', 'FR1']}
# axs.errorbar(range(2), [behavioral_indices['catFR1']['ratio_of_rep'].mean(),
#                         behavioral_indices['FR1']['ratio_of_rep'].mean()],
#              yerr=[se_rr['catFR1'], se_rr['FR1']], fmt='none')
# axs.bar(range(2), [behavioral_indices['catFR1']['ratio_of_rep'].mean(),
#                    behavioral_indices['FR1']['ratio_of_rep'].mean()],
#         yerr=[se_rr['catFR1'], se_rr['FR1']], lw=2,
#         color=['gray', 'lightgray'],
#         error_kw={'ecolor': 'black', 'lw': 2})
error_rr = ci95_rr
axs.bar(range(2), [behavioral_indices['catFR1']['ratio_of_rep'].mean(),
                   behavioral_indices['FR1']['ratio_of_rep'].mean()],
        # yerr=[ci95_rr['catFR1'], ci95_rr['FR1']],
        yerr=[error_rr['catFR1'], error_rr['FR1']],
        color=['gray', 'lightgray'],
        error_kw={'ecolor': 'black', 'lw': 2})
se_rr_diff = (np.std(behavioral_indices['catFR1']['ratio_of_rep']-
                     behavioral_indices['FR1']['ratio_of_rep']) / np.sqrt(
                         len(behavioral_indices['catFR1']['ratio_of_rep'])))
ci95_rr_diff = stats.t.ppf(
    0.975, len(behavioral_indices['catFR1']['ratio_of_rep'])-1)*se_rr_diff
error_rr_diff = ci95_rr_diff
axs.errorbar(0.5, (behavioral_indices['catFR1']['ratio_of_rep'].mean()+
                   behavioral_indices['FR1']['ratio_of_rep'].mean())*0.5,
             yerr=error_rr_diff/2., fmt='none', ecolor='black', lw=2)
# divide by 2 for the error bar between the main bars!

axs.set_xticks([0, 1])
axs.set_xticklabels(['C', 'U'], size='large')
axs.set_xlim((-0.51, 1.51))
axs.set_ylim((0, 0.55))
axs.set_yticks(np.arange(0.0, 0.6, 0.1))
# axs.set_yticklabels([str(rr)[1:] for rr in np.arange(0.0, 0.4, 0.1)],
#                     size='large')
axs.set_yticklabels([rr for rr in np.arange(0.0, 0.6, 0.1)],
                    size='large')
axs.set_ylabel('RR', size='large')
plt.subplots_adjust(left=0.31, right=0.99, bottom=0.11, top=0.99,
                    wspace=0, hspace=0)
# plt.savefig('./figures/pub/FRcatFR_ratio_of_repetitionSE.pdf')
#plt.savefig('./figures/pub/FRcatFR_ratio_of_repetitionCI95.pdf')







import seaborn as sns
#plt.figure()
sns.set_style('white')
sns.set_style("ticks")
fig, ax = plt.subplots(1, 1, figsize=((2,2)))
#ax.axis('off')
# ax.set_frame_on(False)
# ax.axes.xaxis.set_visible(False)
# ax.plot([-0.175,1.175], [0.5, 0.5], 'k') #color='gray', ls='-')
sns.stripplot(data=[behavioral_indices['catFR1']['ratio_of_rep'],
                    behavioral_indices['FR1']['ratio_of_rep']], jitter=True, alpha=0.3, ax=ax, color='black')
# sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
sns.pointplot(data=[behavioral_indices['catFR1']['ratio_of_rep'],
                    behavioral_indices['FR1']['ratio_of_rep']], ax=ax, color='black')
ax.set_xlim((-0.175,1.175))
sns.despine(offset=0, trim=True)
ax.set_xticklabels(['categorized', 'unrelated'])
ax.set_ylabel('RR')
fig.subplots_adjust(left=0.29, bottom=0.16,
                    right=0.94, top=0.999, wspace=0.42, hspace=0.42)
plt.savefig('./figures/pub/FRcatFR_ratio_of_repetitionCI95.pdf')

from scipy.stats import ttest_rel
tval, pval = ttest_rel(behavioral_indices['catFR1']['ratio_of_rep'],
                behavioral_indices['FR1']['ratio_of_rep'])
rr_diff = behavioral_indices['catFR1']['ratio_of_rep']-behavioral_indices['FR1']['ratio_of_rep']
se = np.std(rr_diff, ddof=1)/np.sqrt(len(rr_diff))
df = len(rr_diff)-1
print 't=', tval, 'p=', pval, 'SE=', se, 'df=', df
# In [18]: t= 15.8572436371 p= 3.81776312855e-21 SE= 0.014818877491 df= 50

tval, pval = ttest_rel(behavioral_indices['catFR1']['recalled'],
                behavioral_indices['FR1']['recalled'])
rr_diff = behavioral_indices['catFR1']['recalled']-behavioral_indices['FR1']['recalled']
se = np.std(rr_diff, ddof=1)/np.sqrt(len(rr_diff))
df = len(rr_diff)-1
print 't=', tval, 'p=', pval, 'SE=', se, 'df=', df
# In [24]: t= 6.16364329445 p= 1.21794099282e-07 SE= 0.0121013633536 df= 50


fig, ax = plt.subplots(1, 1, figsize=((1,2)))
#ax.axis('off')
# ax.set_frame_on(False)
# ax.axes.xaxis.set_visible(False)
# ax.plot([-0.175,1.175], [0.5, 0.5], 'k') #color='gray', ls='-')
sns.boxplot(data=[behavioral_indices['catFR1']['ratio_of_rep']-
                  behavioral_indices['FR1']['ratio_of_rep']], ax=ax)
# sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
ax.set_xlim((-0.75,0.75))
sns.despine(offset=0, trim=True)
ax.set_xticklabels([r'C$-$U'])
ax.set_ylabel(r'$\Delta$RR')
fig.subplots_adjust(left=0.6, bottom=0.16,
                    right=0.94, top=0.999, wspace=0.42, hspace=0.42)
plt.savefig('./figures/pub/FRcatFR_deltaRR_boxplot.pdf')




fig, ax = plt.subplots(1, 1, figsize=((1,2)))
#ax.axis('off')
# ax.set_frame_on(False)
# ax.axes.xaxis.set_visible(False)
# ax.plot([-0.175,1.175], [0.5, 0.5], 'k') #color='gray', ls='-')
sns.boxplot(data=[behavioral_indices['catFR1']['ratio_of_rep']-
                  behavioral_indices['FR1']['ratio_of_rep']], ax=ax)
# sns.stripplot(data=[auc_scores['encoding'], auc_scores['retrieval']], jitter=True, ax=ax, color='black')
ax.set_xlim((-0.75,0.75))
sns.despine(offset=0, trim=True)
ax.set_xticklabels([r'C$-$U'])
ax.set_ylabel(r'$\Delta$RR')
fig.subplots_adjust(left=0.6, bottom=0.16,
                    right=0.94, top=0.999, wspace=0.42, hspace=0.42)
plt.savefig('./figures/pub/FRcatFR_deltaRR_boxplot.pdf')






# calculate SPC:

evs_word_bothexp = {}
for label in evs_bothexp:
    evs_word_bothexp[label] = evs_bothexp[label][
        evs_bothexp[label]['type'] == 'WORD']

def get_spc(evs):
    all_recalls = []
    for subj in np.unique(evs['subject']):
        subjrecalls = []
        subjfilt = evs['subject'] == subj
        for sess in np.unique(evs[subjfilt]['session']):
            subjsessfilt = subjfilt & (evs['session'] == sess)
            for lst in np.unique(evs[subjsessfilt]['list']):
                subjsesslstfilt = subjsessfilt & (evs['list'] == lst)
                subjrecalls.append(evs[subjsesslstfilt]['recalled'])
        subjrecalls = np.mean(subjrecalls, 0)
        all_recalls.append(subjrecalls)
    return all_recalls
                

evs_recword_bothexp = {}
for label in evs_bothexp:
    evs_recword_bothexp[label] = evs_bothexp[label][
        evs_bothexp[label]['type'] == 'REC_WORD']

def get_pfr(evs_enc, evs_rec, listlen=12):
    all_pfr = []
    # remove intrusions:
    evs_rec = evs_rec[evs_rec['intrusion'] == 0]
    for subj in np.unique(evs_rec['subject']):
        subjpfr = np.zeros(listlen)
        n_subj = 0
        subjfilt_rec = evs_rec['subject'] == subj
        subjfilt_enc = evs_enc['subject'] == subj
        for sess in np.unique(evs_rec[subjfilt_rec]['session']):
            subjsessfilt_rec = subjfilt_rec & (evs_rec['session'] == sess)
            subjsessfilt_enc = subjfilt_enc & (evs_enc['session'] == sess)
            for lst in np.unique(evs_rec[subjsessfilt_rec]['list']):
                subjsesslstfilt_rec = subjsessfilt_rec & (
                    evs_rec['list'] == lst)
                subjsesslstfilt_enc = subjsessfilt_enc & (
                    evs_enc['list'] == lst)
                first_rec_item = evs_rec[subjsesslstfilt_rec]['item'][0]
                first_rec_sp = evs_enc[
                    subjsesslstfilt_enc &
                    (evs_enc['item'] == first_rec_item)]['serialpos']
                if len(first_rec_sp) == 1:
                    first_rec_sp = first_rec_sp[0]
                else:
                    raise ValueError('Invalid sp! '+str(first_rec_sp))
                subjpfr[first_rec_sp-1] += 1
                n_subj += 1
        subjpfr /= n_subj
        all_pfr.append(subjpfr)
    return all_pfr


def get_crp(evs_enc, evs_rec, listlen=12, exclude_op=0):
    all_crp = []
    lags = np.arange(0, 2*listlen-1)-(listlen-1)
    # remove intrusions:
    evs_rec = evs_rec[evs_rec['intrusion'] == 0]
    for subj in np.unique(evs_rec['subject']):
        subjnumer = np.zeros(len(lags), np.float64)
        subjdenom = np.zeros(len(lags), np.float64)
        subjfilt_rec = evs_rec['subject'] == subj
        subjfilt_enc = evs_enc['subject'] == subj
        for sess in np.unique(evs_rec[subjfilt_rec]['session']):
            subjsessfilt_rec = subjfilt_rec & (evs_rec['session'] == sess)
            subjsessfilt_enc = subjfilt_enc & (evs_enc['session'] == sess)
            for lst in np.unique(evs_rec[subjsessfilt_rec]['list']):
                subjsesslstfilt_rec = subjsessfilt_rec & (
                    evs_rec['list'] == lst)
                subjsesslstfilt_enc = subjsessfilt_enc & (
                    evs_enc['list'] == lst)
                # loop over items in list:
                for r in np.arange(exclude_op, subjsesslstfilt_rec.sum()-1):
                    items = [evs_rec[subjsesslstfilt_rec]['item'][r],
                             evs_rec[subjsesslstfilt_rec]['item'][r+1]]
                    serialpos = [evs_enc[
                        subjsesslstfilt_enc &
                        (evs_enc['item'] == itm)]['serialpos'][0]
                                 for itm in items]

                    # skip repetitions:
                    if (items[0] == items[1]) or np.any(np.in1d(
                            items, evs_rec[subjsesslstfilt_rec]['item'][:r])):
                        continue

                    # increment numerator:
                    lag = np.diff(serialpos)[0]
                    subjnumer[lags == lag] += 1

                    # get all possible lags:
                    neg_lag = np.arange(serialpos[0]-1) - (serialpos[0]-1)
                    pos_lag = np.arange(serialpos[0], listlen) - (
                        serialpos[0]-1)
                    all_lag = np.union1d(neg_lag, pos_lag)

                    # remove lags to previously recalled items:
                    rec_lag = evs_enc[
                        subjsesslstfilt_enc &
                        np.in1d(evs_enc['item'],
                                evs_rec[subjsesslstfilt_rec]['item'][:r])][
                                    'serialpos'] - serialpos[0]
                    good_filt = ~np.in1d(all_lag, rec_lag)
                    all_lag = all_lag[good_filt]

                    # increment the denominator:
                    subjdenom[np.in1d(lags, all_lag)] += 1
        subjdenom[subjdenom == 0] = np.nan
        all_crp.append(subjnumer / subjdenom)
    return lags, all_crp


behdat = {'SPC': {'all': {exp: get_spc(evs_word_bothexp[exp])
                          for exp in evs_word_bothexp}},
          'PFR': {'all': {exp: get_pfr(evs_word_bothexp[exp],
                                       evs_recword_bothexp[exp])
                          for exp in evs_word_bothexp}},
          'CRP': {'all':  {exp: get_crp(evs_word_bothexp[exp],
                                        evs_recword_bothexp[exp])[1]
                           for exp in evs_word_bothexp},
                  'lags': {exp: get_crp(evs_word_bothexp[exp],
                                        evs_recword_bothexp[exp])[0]
                           for exp in evs_word_bothexp}}
}
for plottype in behdat:
    behdat[plottype]['all'][
        'catFR1-FR1'] = (np.array(behdat[plottype]['all']['catFR1'])-
                         np.array(behdat[plottype]['all']['FR1']))


for plottype in behdat:
    behdat[plottype]['mean'] = {exp: np.nanmean(behdat[plottype]['all'][exp], 0)
                                for exp in behdat[plottype]['all']}
    behdat[plottype]['SE'] = {exp: (np.nanstd(
        behdat[plottype]['all'][exp], 0) / np.sqrt(np.sum(np.isfinite(
            behdat[plottype]['all'][exp]), 0)))
                              for exp in behdat[plottype]['all']}
    behdat[plottype]['CI95'] = {exp: behdat[plottype]['SE'][exp] * stats.t.ppf(
        0.975, np.sum(np.isfinite(behdat[plottype]['all'][exp]), 0)-1)
                                for exp in behdat[plottype]['all']}

# fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# fig, axs = plt.subplots(nrows=2, ncols=3, figsize=(9, 3),
# fig, axs = plt.subplots(nrows=2, ncols=3, figsize=(7, 3),
#                         gridspec_kw = {'height_ratios': [6, 2]})
# axs[0, 0].errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
#                    behdat['SPC']['CI95']['FR1'], fmt='k-', lw=2, alpha=0.8,
#                    label='C')
# axs[0, 0].errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
#                    behdat['SPC']['CI95']['FR1'], fmt='g-', lw=2, alpha=0.8,
#                    label='U')
# axs[0, 0].set_xlim((0.5, 12.5))
# axs[0, 0].set_ylim((0, 0.65))
# axs[0, 0].set_xlabel('Serial position', size='large')
# axs[0, 0].set_ylabel('p(recall)', size='large')
# axs[0, 0].set_xticks(range(1, 13))
# # axs[0, 0].set_xticklabels(range(1, 13), size='large')
# axs[0, 0].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11],
#                           size='large')
# axs[0, 0].set_yticks(np.arange(0, 0.61, 0.1))
# axs[0, 0].set_yticklabels(np.arange(0, 0.61, 0.1), size='large')
# # fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# axs[1, 0].errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
#                    behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
#                    lw=2, alpha=0.8)
# axs[1, 0].plot([0.5, 12.5], [0, 0], 'k--', lw=2)
# axs[1, 0].set_xlim((0.5, 12.5))
# axs[1, 0].set_ylim((-0.15, 0.15))
# axs[1, 0].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# axs[1, 0].set_xticks(range(1, 13))
# # axs[1, 0].set_xticklabels(range(1, 13), size='large')
# axs[1, 0].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11],
#                           size='large')
# axs[1, 0].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 0].set_yticklabels([-0.1, 0.0, 0.1], size='large')
# axs[1, 0].set_ylabel(r"$\Delta$"+'p', size='large')

# axs[0, 1].errorbar(range(1, 13), behdat['PFR']['mean']['catFR1'],
#                    behdat['PFR']['CI95']['FR1'], fmt='k-', lw=2, alpha=0.8,
#                    label='C')
# axs[0, 1].errorbar(range(1, 13), behdat['PFR']['mean']['FR1'],
#                    behdat['PFR']['CI95']['FR1'], fmt='g-', lw=2, alpha=0.8,
#                    label='U')
# axs[0, 1].set_xlim((0.5, 12.5))
# # axs[0, 1].set_ylim((0, 0.65))
# axs[0, 1].set_ylim((0, 0.45))
# axs[0, 1].set_xlabel('Serial position', size='large')
# axs[0, 1].set_ylabel('p(first recall)', size='large')
# axs[0, 1].set_xticks(range(1, 13))
# # axs[0, 1].set_xticklabels(range(1, 13), size='large')
# axs[0, 1].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11],
#                           size='large')
# axs[0, 1].set_yticks(np.arange(0, 0.41, 0.1))
# axs[0, 1].set_yticklabels(np.arange(0, 0.41, 0.1), size='large')
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 1].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 1].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)

# axs[1, 1].errorbar(range(1, 13), behdat['PFR']['mean']['catFR1-FR1'],
#                 behdat['PFR']['CI95']['catFR1-FR1'], fmt='k-',
#                    lw=2, alpha=0.8)
# axs[1, 1].plot([0.5, 12.5], [0, 0], 'k--', lw=2)
# axs[1, 1].set_xlim((0.5, 12.5))
# axs[1, 1].set_ylim((-0.15, 0.15))
# axs[1, 1].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# axs[1, 1].set_xticks(range(1, 13))
# # axs[1, 1].set_xticklabels(range(1, 13), size='large')
# axs[1, 1].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11],
#                           size='large')
# axs[1, 1].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 1].set_yticklabels([-0.1, 0.0, 0.1], size='large')
# axs[1, 1].set_ylabel(r"$\Delta$"+'p', size='large')

# crp_lags = range(-6, 7)
# axs[0, 2].errorbar(crp_lags, #behdat['CRP']['lags']['catFR1'],
#                 behdat['CRP']['mean']['catFR1'][
#                     np.in1d(behdat['CRP']['lags']['catFR1'], crp_lags)],
#                 behdat['CRP']['CI95']['catFR1'][
#                     np.in1d(behdat['CRP']['lags']['catFR1'], crp_lags)],
#                    fmt='k-', lw=2, alpha=0.8, label='C')
# axs[0, 2].errorbar(crp_lags, #behdat['CRP']['lags']['FR1'],
#                 behdat['CRP']['mean']['FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                 behdat['CRP']['CI95']['FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                    fmt='g-', lw=2, alpha=0.8, label='U')
# axs[0, 2].set_xlim((-6.5, 6.5))
# axs[0, 2].set_ylim((0, 0.45))
# axs[0, 2].set_xlabel('Lag', size='large')
# axs[0, 2].set_ylabel('CRP', size='large')
# axs[0, 2].set_xticks(range(-6, 7))
# # axs[0, 2].set_xticklabels(range(-6, 7), size='large')
# axs[0, 2].set_xticklabels([-6, '', -4, '', -2, '', 0, '', 2, '', 4, '', 6],
#                           size='large')
# axs[0, 2].set_yticks(np.arange(0, 0.41, 0.1))
# axs[0, 2].set_yticklabels(np.arange(0, 0.41, 0.1), size='large')
# crp_lags = range(-6, 7)
# axs[1, 2].errorbar(crp_lags, #behdat['CRP']['lags']['FR1'],
#                 behdat['CRP']['mean']['catFR1-FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                 behdat['CRP']['CI95']['catFR1-FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                    fmt='k-', lw=2, alpha=0.8)
# # axs[1, 2].plot([-6.5, 6.5], [0, 0], 'k--', lw=2)
# axs[1, 2].plot([-6.5, -0.5], [0, 0], 'k--', lw=2)
# axs[1, 2].plot([0.5, 6.5], [0, 0], 'k--', lw=2)
# axs[1, 2].set_xlim((-6.5, 6.5))
# axs[1, 2].set_ylim((-0.15, 0.15))
# axs[1, 2].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# axs[1, 2].set_xticks(range(-6, 7))
# # axs[1, 2].set_xticklabels(range(-6, 7), size='large')
# axs[1, 2].set_xticklabels([-6, '', -4, '', -2, '', 0, '', 2, '', 4, '', 6],
#                           size='large')
# axs[1, 2].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 2].set_yticklabels([-0.1, 0.0, 0.1], size='large')
# axs[1, 2].set_ylabel(r"$\Delta$"+'p', size='large')
# # plt.subplots_adjust(left=0.06, right=0.995, bottom=0.05, top=0.99,
# #                     wspace=0.25, hspace=0.55)
# # plt.subplots_adjust(left=0.08, right=0.999, bottom=0.01, top=0.99,
# #                     wspace=0.35, hspace=0.8)
# plt.subplots_adjust(left=0.1, right=0.996, bottom=0.01, top=0.99,
#                     wspace=0.5, hspace=0.8)
# plt.savefig('./figures/pub/FRcatFR_behavioral.pdf')

# fig, axs = plt.subplots(nrows=2, ncols=3, figsize=(7, 3),
#                         gridspec_kw = {'height_ratios': [6, 2]})
# axs[0, 0].errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
#                    behdat['SPC']['CI95']['FR1'], fmt='k-', lw=2, alpha=0.8,
#                    label='C')
# axs[0, 0].errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
#                    behdat['SPC']['CI95']['FR1'], fmt='g-', lw=2, alpha=0.8,
#                    label='U')
# axs[0, 0].set_xlim((0.5, 12.5))
# axs[0, 0].set_ylim((0, 0.65))
# axs[0, 0].set_ylim((0.15, 0.65))
# axs[0, 0].set_xlabel('Serial position', labelpad=1)
# axs[0, 0].set_ylabel('p(recall)')#, size='large')
# axs[0, 0].set_xticks(range(1, 13))
# # axs[0, 0].set_xticklabels(range(1, 13), size='large')
# axs[0, 0].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])#,
# #                          size='large')
# #axs[0, 0].set_yticks(np.arange(0, 0.61, 0.1))
# #axs[0, 0].set_yticklabels(np.arange(0, 0.61, 0.1), size='large')
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 0].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 0].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)
# sns.despine(offset=0, trim=True, ax=axs[0, 0])
# axs[0, 0].xaxis.set_tick_params(pad=3)
# axs[0, 0].yaxis.set_tick_params(pad=3)


# # fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# axs[1, 0].errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
#                    behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
#                    lw=2, alpha=0.8)
# axs[1, 0].plot([0.5, 12.5], [0, 0], 'k--', lw=2)
# axs[1, 0].set_xlim((0.5, 12.5))
# axs[1, 0].set_ylim((-0.15, 0.15))
# axs[1, 0].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# axs[1, 0].set_xticks(range(1, 13))
# # axs[1, 0].set_xticklabels(range(1, 13), size='large')
# axs[1, 0].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
# axs[1, 0].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 0].set_yticklabels([-0.1, 0.0, 0.1])
# axs[1, 0].set_ylabel(r"$\Delta$"+'p', labelpad=1)
# sns.despine(offset=0, trim=True, top=False, right=True, left=False, bottom=True, ax=axs[1, 0])
# axs[1, 0].xaxis.set_tick_params(pad=-1)
# axs[1, 0].yaxis.set_tick_params(pad=3)



# axs[0, 1].errorbar(range(1, 13), behdat['PFR']['mean']['catFR1'],
#                    behdat['PFR']['CI95']['FR1'], fmt='k-', lw=2, alpha=0.8,
#                    label='C')
# axs[0, 1].errorbar(range(1, 13), behdat['PFR']['mean']['FR1'],
#                    behdat['PFR']['CI95']['FR1'], fmt='g-', lw=2, alpha=0.8,
#                    label='U')
# axs[0, 1].set_xlim((0.5, 12.5))
# # axs[0, 1].set_ylim((0, 0.65))
# axs[0, 1].set_ylim((0, 0.45))
# axs[0, 1].set_xlabel('Serial position', labelpad=1)
# axs[0, 1].set_ylabel('p(first recall)')
# axs[0, 1].set_xticks(range(1, 13))
# # axs[0, 1].set_xticklabels(range(1, 13), size='large')
# axs[0, 1].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
# # axs[0, 1].set_yticks(np.arange(0, 0.41, 0.1))
# #axs[0, 1].set_yticklabels(np.arange(0, 0.41, 0.1))
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 1].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 1].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)
# sns.despine(offset=0, trim=True, ax=axs[0, 1])
# axs[0, 1].xaxis.set_tick_params(pad=3)
# axs[0, 1].yaxis.set_tick_params(pad=3)



# axs[1, 1].errorbar(range(1, 13), behdat['PFR']['mean']['catFR1-FR1'],
#                 behdat['PFR']['CI95']['catFR1-FR1'], fmt='k-',
#                    lw=2, alpha=0.8)
# axs[1, 1].plot([0.5, 12.5], [0, 0], 'k--', lw=2)
# axs[1, 1].set_xlim((0.5, 12.5))
# axs[1, 1].set_ylim((-0.15, 0.15))
# axs[1, 1].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# axs[1, 1].set_xticks(range(1, 13))
# # axs[1, 1].set_xticklabels(range(1, 13), size='large')
# axs[1, 1].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
# axs[1, 1].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 1].set_yticklabels([-0.1, 0.0, 0.1])
# axs[1, 1].set_ylabel(r"$\Delta$"+'p', labelpad=1)
# sns.despine(offset=0, trim=True, top=False, right=True, left=False, bottom=True, ax=axs[1, 1])
# axs[1, 1].xaxis.set_tick_params(pad=-1)
# axs[1, 1].yaxis.set_tick_params(pad=3)

# crp_lags = range(-6, 7)
# axs[0, 2].errorbar(crp_lags, #behdat['CRP']['lags']['catFR1'],
#                 behdat['CRP']['mean']['catFR1'][
#                     np.in1d(behdat['CRP']['lags']['catFR1'], crp_lags)],
#                 behdat['CRP']['CI95']['catFR1'][
#                     np.in1d(behdat['CRP']['lags']['catFR1'], crp_lags)],
#                    fmt='k-', lw=2, alpha=0.8, label='C')
# axs[0, 2].errorbar(crp_lags, #behdat['CRP']['lags']['FR1'],
#                 behdat['CRP']['mean']['FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                 behdat['CRP']['CI95']['FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                    fmt='g-', lw=2, alpha=0.8, label='U')
# axs[0, 2].set_xlim((-6.5, 6.5))
# axs[0, 2].set_ylim((0, 0.45))
# axs[0, 2].set_xlabel('Lag', labelpad=1)
# axs[0, 2].set_ylabel('CRP', labelpad=1)
# axs[0, 2].set_xticks(range(-6, 7))
# # axs[0, 2].set_xticklabels(range(-6, 7), size='large')
# axs[0, 2].set_xticklabels([-6, '', -4, '', -2, '', 0, '', 2, '', 4, '', 6])
# #axs[0, 2].set_yticks(np.arange(0, 0.41, 0.1))
# #axs[0, 2].set_yticklabels(np.arange(0, 0.41, 0.1), size='large')
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 1].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 2].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)
# sns.despine(offset=0, trim=True, ax=axs[0, 2])
# axs[0, 2].xaxis.set_tick_params(pad=3)
# axs[0, 2].yaxis.set_tick_params(pad=3)


# crp_lags = range(-6, 7)
# axs[1, 2].errorbar(crp_lags, #behdat['CRP']['lags']['FR1'],
#                 behdat['CRP']['mean']['catFR1-FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                 behdat['CRP']['CI95']['catFR1-FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                    fmt='k-', lw=2, alpha=0.8)
# # axs[1, 2].plot([-6.5, 6.5], [0, 0], 'k--', lw=2)
# axs[1, 2].plot([-6.5, -0.5], [0, 0], 'k--', lw=2)
# axs[1, 2].plot([0.5, 6.5], [0, 0], 'k--', lw=2)
# axs[1, 2].set_xlim((-6.5, 6.5))
# axs[1, 2].set_ylim((-0.15, 0.15))
# axs[1, 2].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# # axs[1, 2].xaxis.set_tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
# # axs[1, 2].ax.xaxis.set_label_position('top') 
# #axs[1, 2].xaxis.tick_top()
# #axs[1, 2].xaxis.set_ticks_position('top')
# axs[1, 2].set_xticks(range(-6, 7))
# # axs[1, 2].set_xticklabels(range(-6, 7), size='large')
# axs[1, 2].set_xticklabels([-6, '', -4, '', -2, '', 0, '', 2, '', 4, '', 6])
# axs[1, 2].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 2].set_yticklabels([-0.1, 0.0, 0.1])
# axs[1, 2].set_ylabel(r"$\Delta$"+'p', labelpad=1)
# # plt.subplots_adjust(left=0.06, right=0.995, bottom=0.05, top=0.99,
# #                     wspace=0.25, hspace=0.55)
# # plt.subplots_adjust(left=0.08, right=0.999, bottom=0.01, top=0.99,
# #                     wspace=0.35, hspace=0.8)
# sns.despine(offset=0, trim=True, top=False, right=True, left=False, bottom=True, ax=axs[1, 2])
# axs[1, 2].xaxis.set_tick_params(pad=-1)
# axs[1, 2].yaxis.set_tick_params(pad=3)

# plt.subplots_adjust(left=0.08, right=0.999, bottom=0.005, top=0.9999,
#                     wspace=0.4, hspace=0.6)
# plt.savefig('./figures/pub/FRcatFR_performance.pdf')














fig, axs = plt.subplots(nrows=2, ncols=3, figsize=(7, 3),
                        gridspec_kw = {'height_ratios': [5, 2]})
axs[0, 0].errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
                   behdat['SPC']['CI95']['FR1'], fmt='k-', lw=2, alpha=0.8,
                   label='C')
axs[0, 0].errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
                   behdat['SPC']['CI95']['FR1'], fmt='g-', lw=2, alpha=0.8,
                   label='U')
axs[0, 0].set_xlim((0.5, 12.5))
axs[0, 0].set_ylim((0, 0.65))
axs[0, 0].set_ylim((0., 0.65))
axs[0, 0].set_ylabel('p(recall)')#, size='large')
axs[0, 0].xaxis.set_visible(False)
# http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 0].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 0].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)
sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=axs[0, 0])
#axs[0, 0].xaxis.set_tick_params(pad=3)
axs[0, 0].yaxis.set_tick_params(pad=3)


# fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
axs[1, 0].errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
                   behdat['SPC']['CI95']['catFR1-FR1'], fmt='k-',
                   lw=2, alpha=0.8)
axs[1, 0].plot([0.5, 12.5], [0, 0], 'k--', lw=2)
axs[1, 0].set_xlim((0.5, 12.5))
axs[1, 0].set_ylim((-0.1, 0.15))
#axs[1, 0].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
axs[1, 0].set_xticks(range(1, 13))
# axs[1, 0].set_xticklabels(range(1, 13), size='large')
axs[1, 0].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
axs[1, 0].set_xlabel('Serial position', labelpad=1)
axs[1, 0].set_yticks([-0.1, 0.0, 0.1])
axs[1, 0].set_yticklabels([-0.1, 0.0, 0.1])
axs[1, 0].set_ylabel(r"$\Delta$"+'p', labelpad=1)
sns.despine(offset=0, trim=True, ax=axs[1, 0])
axs[1, 0].xaxis.set_tick_params(pad=3)
axs[1, 0].yaxis.set_tick_params(pad=3)



axs[0, 1].errorbar(range(1, 13), behdat['PFR']['mean']['catFR1'],
                   behdat['PFR']['CI95']['FR1'], fmt='k-', lw=2, alpha=0.8,
                   label='C')
axs[0, 1].errorbar(range(1, 13), behdat['PFR']['mean']['FR1'],
                   behdat['PFR']['CI95']['FR1'], fmt='g-', lw=2, alpha=0.8,
                   label='U')
axs[0, 1].set_xlim((0.5, 12.5))
# axs[0, 1].set_ylim((0, 0.65))
axs[0, 1].set_ylim((0, 0.45))
#axs[0, 1].set_xlabel('Serial position', labelpad=1)
axs[0, 1].set_ylabel('p(first recall)')
axs[0, 1].xaxis.set_visible(False)
# http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 1].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 1].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)
sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=axs[0, 1])
#axs[0, 1].xaxis.set_tick_params(pad=3)
axs[0, 1].yaxis.set_tick_params(pad=3)



axs[1, 1].errorbar(range(1, 13), behdat['PFR']['mean']['catFR1-FR1'],
                behdat['PFR']['CI95']['catFR1-FR1'], fmt='k-',
                   lw=2, alpha=0.8)
axs[1, 1].plot([0.5, 12.5], [0, 0], 'k--', lw=2)
axs[1, 1].set_xlim((0.5, 12.5))
axs[1, 1].set_ylim((-0.1, 0.15))
# axs[1, 1].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
axs[1, 1].set_xticks(range(1, 13))
# axs[1, 1].set_xticklabels(range(1, 13), size='large')
axs[1, 1].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11])
axs[1, 1].set_xlabel('Serial position', labelpad=1)
axs[1, 1].set_yticks([-0.1, 0.0, 0.1])
axs[1, 1].set_yticklabels([-0.1, 0.0, 0.1])
axs[1, 1].set_ylabel(r"$\Delta$"+'p', labelpad=1)
sns.despine(offset=0, trim=True, ax=axs[1, 1])
axs[1, 1].xaxis.set_tick_params(pad=3)
axs[1, 1].yaxis.set_tick_params(pad=3)

crp_lags = range(-6, 7)
axs[0, 2].errorbar(crp_lags, #behdat['CRP']['lags']['catFR1'],
                behdat['CRP']['mean']['catFR1'][
                    np.in1d(behdat['CRP']['lags']['catFR1'], crp_lags)],
                behdat['CRP']['CI95']['catFR1'][
                    np.in1d(behdat['CRP']['lags']['catFR1'], crp_lags)],
                   fmt='k-', lw=2, alpha=0.8, label='C')
axs[0, 2].errorbar(crp_lags, #behdat['CRP']['lags']['FR1'],
                behdat['CRP']['mean']['FR1'][
                    np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
                behdat['CRP']['CI95']['FR1'][
                    np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
                   fmt='g-', lw=2, alpha=0.8, label='U')
axs[0, 2].set_xlim((-6.5, 6.5))
axs[0, 2].set_ylim((0, 0.45))
axs[0, 2].set_ylabel('CRP', labelpad=1)
axs[0, 2].xaxis.set_visible(False)
# http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
handles, labels = axs[0, 1].get_legend_handles_labels()
handles = [h[0] for h in handles]
axs[0, 2].legend(handles, labels, loc='upper right',
                 frameon=False, borderpad=0)
sns.despine(offset=0, trim=True, top=True, right=True, left=False, bottom=True, ax=axs[0, 2])
#axs[0, 2].xaxis.set_tick_params(pad=3)
axs[0, 2].yaxis.set_tick_params(pad=3)


crp_lags = range(-6, 7)
axs[1, 2].errorbar(crp_lags, #behdat['CRP']['lags']['FR1'],
                behdat['CRP']['mean']['catFR1-FR1'][
                    np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
                behdat['CRP']['CI95']['catFR1-FR1'][
                    np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
                   fmt='k-', lw=2, alpha=0.8)
# axs[1, 2].plot([-6.5, 6.5], [0, 0], 'k--', lw=2)
axs[1, 2].plot([-6.5, -0.5], [0, 0], 'k--', lw=2)
axs[1, 2].plot([0.5, 6.5], [0, 0], 'k--', lw=2)
axs[1, 2].set_xlim((-6.5, 6.5))
axs[1, 2].set_ylim((-0.1, 0.15))
#axs[1, 2].tick_params(labelbottom='off',labeltop='on', bottom='off', top='on')
axs[1, 2].set_xticks(range(-6, 7))
# axs[1, 2].set_xticklabels(range(-6, 7), size='large')
axs[1, 2].set_xticklabels([-6, '', -4, '', -2, '', 0, '', 2, '', 4, '', 6])
axs[1, 2].set_xlabel('Lag', labelpad=1)
axs[1, 2].set_yticks([-0.1, 0.0, 0.1])
axs[1, 2].set_yticklabels([-0.1, 0.0, 0.1])
axs[1, 2].set_ylabel(r"$\Delta$"+'p', labelpad=1)
# plt.subplots_adjust(left=0.06, right=0.995, bottom=0.05, top=0.99,
#                     wspace=0.25, hspace=0.55)
# plt.subplots_adjust(left=0.08, right=0.999, bottom=0.01, top=0.99,
#                     wspace=0.35, hspace=0.8)
sns.despine(offset=0, trim=True, ax=axs[1, 2])
axs[1, 2].xaxis.set_tick_params(pad=3)
axs[1, 2].yaxis.set_tick_params(pad=3)

plt.subplots_adjust(left=0.08, right=0.999, bottom=0.15, top=0.9999,
                    wspace=0.35, hspace=0.05)


plt.savefig('./figures/pub/FRcatFR_performance.pdf')























# fig, axs = plt.subplots(nrows=2, ncols=3, figsize=(7, 3),
#                         gridspec_kw = {'height_ratios': [6, 2]})
# axs[0, 0].errorbar(range(1, 13), behdat['SPC']['mean']['catFR1'],
#                    behdat['SPC']['SE']['FR1'], fmt='k-', lw=2, alpha=0.8,
#                    label='C')
# axs[0, 0].errorbar(range(1, 13), behdat['SPC']['mean']['FR1'],
#                    behdat['SPC']['SE']['FR1'], fmt='g-', lw=2, alpha=0.8,
#                    label='U')
# axs[0, 0].set_xlim((0.5, 12.5))
# axs[0, 0].set_ylim((0, 0.65))
# axs[0, 0].set_xlabel('Serial position', size='large')
# axs[0, 0].set_ylabel('p(recall)', size='large')
# axs[0, 0].set_xticks(range(1, 13))
# # axs[0, 0].set_xticklabels(range(1, 13), size='large')
# axs[0, 0].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11],
#                           size='large')
# axs[0, 0].set_yticks(np.arange(0, 0.61, 0.1))
# axs[0, 0].set_yticklabels(np.arange(0, 0.61, 0.1), size='large')
# # fig, axs = plt.subplots(nrows=1, ncols=3, figsize=(12, 4))
# axs[1, 0].errorbar(range(1, 13), behdat['SPC']['mean']['catFR1-FR1'],
#                    behdat['SPC']['SE']['catFR1-FR1'], fmt='k-',
#                    lw=2, alpha=0.8)
# axs[1, 0].plot([0.5, 12.5], [0, 0], 'k--', lw=2)
# axs[1, 0].set_xlim((0.5, 12.5))
# axs[1, 0].set_ylim((-0.15, 0.15))
# axs[1, 0].tick_params(labelbottom='off',labeltop='on')
# axs[1, 0].set_xticks(range(1, 13))
# # axs[1, 0].set_xticklabels(range(1, 13), size='large')
# axs[1, 0].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11],
#                           size='large')
# axs[1, 0].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 0].set_yticklabels([-0.1, 0.0, 0.1], size='large')
# axs[1, 0].set_ylabel(r"$\Delta$"+'p', size='large')

# axs[0, 1].errorbar(range(1, 13), behdat['PFR']['mean']['catFR1'],
#                    behdat['PFR']['SE']['FR1'], fmt='k-', lw=2, alpha=0.8,
#                    label='C')
# axs[0, 1].errorbar(range(1, 13), behdat['PFR']['mean']['FR1'],
#                    behdat['PFR']['SE']['FR1'], fmt='g-', lw=2, alpha=0.8,
#                    label='U')
# axs[0, 1].set_xlim((0.5, 12.5))
# # axs[0, 1].set_ylim((0, 0.65))
# axs[0, 1].set_ylim((0, 0.45))
# axs[0, 1].set_xlabel('Serial position', size='large')
# axs[0, 1].set_ylabel('p(first recall)', size='large')
# axs[0, 1].set_xticks(range(1, 13))
# # axs[0, 1].set_xticklabels(range(1, 13), size='large')
# axs[0, 1].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11],
#                           size='large')
# axs[0, 1].set_yticks(np.arange(0, 0.41, 0.1))
# axs[0, 1].set_yticklabels(np.arange(0, 0.41, 0.1), size='large')
# # http://stackoverflow.com/questions/14297714/matplotlib-dont-show-errorbars-in-legend
# handles, labels = axs[0, 1].get_legend_handles_labels()
# handles = [h[0] for h in handles]
# axs[0, 1].legend(handles, labels, loc='upper right',
#                  frameon=False, borderpad=0)

# axs[1, 1].errorbar(range(1, 13), behdat['PFR']['mean']['catFR1-FR1'],
#                 behdat['PFR']['SE']['catFR1-FR1'], fmt='k-',
#                    lw=2, alpha=0.8)
# axs[1, 1].plot([0.5, 12.5], [0, 0], 'k--', lw=2)
# axs[1, 1].set_xlim((0.5, 12.5))
# axs[1, 1].set_ylim((-0.15, 0.15))
# axs[1, 1].tick_params(labelbottom='off',labeltop='on')
# axs[1, 1].set_xticks(range(1, 13))
# # axs[1, 1].set_xticklabels(range(1, 13), size='large')
# axs[1, 1].set_xticklabels([1, '', 3, '', 5, '', 7, '', 9, '', 11],
#                           size='large')
# axs[1, 1].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 1].set_yticklabels([-0.1, 0.0, 0.1], size='large')
# axs[1, 1].set_ylabel(r"$\Delta$"+'p', size='large')

# crp_lags = range(-6, 7)
# axs[0, 2].errorbar(crp_lags, #behdat['CRP']['lags']['catFR1'],
#                 behdat['CRP']['mean']['catFR1'][
#                     np.in1d(behdat['CRP']['lags']['catFR1'], crp_lags)],
#                 behdat['CRP']['SE']['catFR1'][
#                     np.in1d(behdat['CRP']['lags']['catFR1'], crp_lags)],
#                    fmt='k-', lw=2, alpha=0.8, label='C')
# axs[0, 2].errorbar(crp_lags, #behdat['CRP']['lags']['FR1'],
#                 behdat['CRP']['mean']['FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                 behdat['CRP']['SE']['FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                    fmt='g-', lw=2, alpha=0.8, label='U')
# axs[0, 2].set_xlim((-6.5, 6.5))
# axs[0, 2].set_ylim((0, 0.45))
# axs[0, 2].set_xlabel('Lag', size='large')
# axs[0, 2].set_ylabel('CRP', size='large')
# axs[0, 2].set_xticks(range(-6, 7))
# # axs[0, 2].set_xticklabels(range(-6, 7), size='large')
# axs[0, 2].set_xticklabels([-6, '', -4, '', -2, '', 0, '', 2, '', 4, '', 6],
#                           size='large')
# axs[0, 2].set_yticks(np.arange(0, 0.41, 0.1))
# axs[0, 2].set_yticklabels(np.arange(0, 0.41, 0.1), size='large')
# crp_lags = range(-6, 7)
# axs[1, 2].errorbar(crp_lags, #behdat['CRP']['lags']['FR1'],
#                 behdat['CRP']['mean']['catFR1-FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                 behdat['CRP']['SE']['catFR1-FR1'][
#                     np.in1d(behdat['CRP']['lags']['FR1'], crp_lags)],
#                    fmt='k-', lw=2, alpha=0.8)
# # axs[1, 2].plot([-6.5, 6.5], [0, 0], 'k--', lw=2)
# axs[1, 2].plot([-6.5, -0.5], [0, 0], 'k--', lw=2)
# axs[1, 2].plot([0.5, 6.5], [0, 0], 'k--', lw=2)
# axs[1, 2].set_xlim((-6.5, 6.5))
# axs[1, 2].set_ylim((-0.15, 0.15))
# axs[1, 2].tick_params(labelbottom='off',labeltop='on')
# axs[1, 2].set_xticks(range(-6, 7))
# # axs[1, 2].set_xticklabels(range(-6, 7), size='large')
# axs[1, 2].set_xticklabels([-6, '', -4, '', -2, '', 0, '', 2, '', 4, '', 6],
#                           size='large')
# axs[1, 2].set_yticks([-0.1, 0.0, 0.1])
# axs[1, 2].set_yticklabels([-0.1, 0.0, 0.1], size='large')
# axs[1, 2].set_ylabel(r"$\Delta$"+'p', size='large')
# # plt.subplots_adjust(left=0.06, right=0.995, bottom=0.05, top=0.99,
# #                     wspace=0.25, hspace=0.55)
# # plt.subplots_adjust(left=0.08, right=0.999, bottom=0.01, top=0.99,
# #                     wspace=0.35, hspace=0.8)
# plt.subplots_adjust(left=0.1, right=0.996, bottom=0.01, top=0.99,
#                     wspace=0.5, hspace=0.8)
# plt.savefig('./figures/pub/FRcatFR_behavioralSE.pdf')





