import numpy as np
import glob

from scipy.io import loadmat
# evfile_date = '20160802'
# evfile_date = '20161101'
# evfile_date = '20170201'
# evfile_date = '20170411'
evfile_date = '20180109'
# ev_params = {
#     'catFR1_retrieval':{
#         'event_path': '/home/ctw/fusemounts/rhino/scratch/jkragel/events_pre2000_post1500/RAM_CatFR1/',
#         'bad_subjects': [],
#         'outfile': '/home/ctw/Christoph/Analyses/RAM/RAM_catFR/data/'+
#         'RAM_catFR1_events'+evfile_date+'_jim.npy'},
#     'FR1_retrieval':{
#         'event_path': '/home/ctw/fusemounts/rhino/scratch/jkragel/events_pre2000_post1500/RAM_FR1/',
#         'bad_subjects': [],
#         'outfile': '/home/ctw/Christoph/Analyses/RAM/RAM_FR/data/'+
#         'RAM_FR1_events'+evfile_date+'_jim.npy'}
# }
ev_params = {
    'catFR1':{
        'event_path': '/home/ctw/fusemounts/rhino/scratch/jkragel/events/catfr_mscript/RAM_CatFR1/',
        'bad_subjects': [],
        'outfile': '/home/ctw/Christoph/Analyses/RAM/RAM_catFR/data/'+
        'RAM_catFR1_events'+evfile_date+'_jim.npy'},
    'FR1':{
        'event_path': '/home/ctw/fusemounts/rhino/scratch/jkragel/events/catfr_mscript/RAM_FR1/',
        'bad_subjects': [],
        'outfile': '/home/ctw/Christoph/Analyses/RAM/RAM_FR/data/'+
        'RAM_FR1_events'+evfile_date+'_jim.npy'}
}


# dtypes_stimParams = [('hostTime', np.float), ('elec1', np.float),
#                      ('elec2', np.float), ('amplitude', np.float),
#                      ('burstFreq', np.float), ('nBursts', np.float),
#                      ('pulseFreq', np.float), ('nPulses', np.float),
#                      ('pulseWidth', np.float)]


# dtypes = [('subject','|S12'),('session',np.int), ('list',np.int),
#           ('serialpos', np.int), ('type', '|S20'), ('item','|S20'),
#           ('itemno',np.int),('recalled',np.int), ('mstime',np.float),
#           ('msoffset',np.int),('rectime',np.int), ('intrusion',np.int),
#           ('isStim', np.int), ('category','|S20' ), ('categoryNum', np.int),
#           ('expVersion','|S32' ), ('stimAnode', np.float),
#           ('stimAnodeTag', 'O'),
#           ('stimCathode', np.float), ('stimCathodeTag', 'O'),
#           ('stimLoc', 'S12'),
#           ('stimAmp', np.float), ('stimList', np.int),
#           # ('stimParams_hostTime', np.float), ('stimParams_elec1', np.float),
#           ('stimParams', 'O'),
#           ('eegfile','|S256'), ('eegoffset', np.int), ('repeat', np.float),
#           ('pirt', np.float), ('error_match', np.float),
#           ('rec_error', np.float), ('output_position', np.float),
#           ('within_cat', np.float), ('between_cat', np.float),
#           ('rec_good', np.float), ('rec_word', np.float),
#           ('rec_base', np.float)]

dtypes = [('subject','|S12'),('session',np.int), ('list',np.int),
          ('serialpos', np.float), ('type', '|S20'), ('item','|S20'),
          ('itemno',np.int),('recalled', np.float), ('mstime',np.float),
          ('msoffset',np.int),('rectime', np.int), ('intrusion',np.int),
          ('is_stim', np.float), ('category','|S20' ), ('categoryNum', np.int),
          ('experiment','|S32' ), ('exp_version','|S32' ),
          ('stimAnode', np.float), ('stimAnodeTag', 'O'),
          ('stimCathode', np.float), ('stimCathodeTag', 'O'),
          ('stimLoc', 'S12'), ('montage', 'S12'), ('protocol', 'S12'), 
          ('stimAmp', np.float), ('stim_list', np.float),
          # ('stimParams_hostTime', np.float), ('stimParams_elec1', np.float),
          ('stimParams', 'O'), ('phase', 'S32'), ('recog_resp', np.int),
          ('recog_rt', np.int), ('recognized', np.int), ('rejected', np.int),
          ('eegfile','|S256'),
          ('eegoffset', np.int), ('repeat', np.float), ('pirt', np.float),
          ('output_position', np.float), ('within_cat', np.float),
          ('between_cat', np.float), ('rec_base_match', np.float)]
excluded_field = ['error_match', 'rec_error', 'rec_good', 'stimParams']


for exp in ev_params:
    event_struct_list = sorted(glob.glob(ev_params[exp]['event_path']+'R1*_events.mat'))
    # event_struct_list.extend(glob.glob(ev_params[exp]['event_path']+'TJ*_events.mat'))
    # event_struct_list.extend(glob.glob(ev_params[exp]['event_path']+'UT*_events.mat'))
    good_events = np.ones(len(event_struct_list), np.bool)
    for e,evfile in enumerate(event_struct_list):
        for bs in ev_params[exp]['bad_subjects']:
            if bs in evfile:
                good_events[e] = False
    event_struct_list = np.array(event_struct_list)[good_events]

    fixfields = [
        ('itemno', np.int, -999), ('intrusion', np.int, -999),
        ('categoryNum', np.int, -999), ('stimAnode', np.float, np.nan),
        ('stimCathode', np.float, np.nan), ('msoffset', np.int, -999),
        ('stimAmp', np.float, np.nan), ('repeat', np.int, np.nan),
        ('pirt', np.int, np.nan), ('error_match', np.int, np.nan),
        ('rec_error', np.int, np.nan), ('output_position', np.int, np.nan),
        ('within_cat', np.int, np.nan), ('between_cat', np.int, np.nan),
        ('rec_good', np.int, np.nan), ('isStim', np.int, -999)]
    all_evs = None
    for datfile in event_struct_list:
        print datfile
        evs = loadmat(datfile,struct_as_record=True, squeeze_me=True)['events']
        newevs = np.rec.recarray(len(evs),dtype=dtypes)
        for ff, dt, val in fixfields:
            if ff in evs.dtype.names:
                evs[ff][~np.array([isinstance(e, dt)  for e in evs[ff]])] = val
        if (('within_cat' in evs.dtype.names) |
            ('between_cat' in evs.dtype.names)):
            rec_base_match = (
                (evs['type'] == 'REC_WORD') & (evs['intrusion'] == 0) &
                (evs['repeat'] == 0) & (evs['output_position'] != 1) &
                (evs['pirt'] > 1500) & ((evs['within_cat'] == 1) |
                                        (evs['between_cat'] == 1)))
        else:
            rec_base_match = (
                (evs['type'] == 'REC_WORD') & (evs['intrusion'] == 0) &
                (evs['repeat'] == 0) & (evs['output_position'] != 1) &
                (evs['pirt'] > 1500))
            newevs['within_cat'] = np.nan
            newevs['between_cat'] = np.nan
        # enc_word = evs['type'] == 'WORD'
        # rec_word = evs['type'] == 'REC_WORD'
        # rec_base = evs['type'] == 'REC_BASE'
        # valid_events = enc_word | rec_word | rec_base
        # evs = evs[valid_events]
        newevs['rec_base_match'] = rec_base_match
        # newevs_stimParams = np.rec.recarray(len(evs), dtype=dtypes_stimParams)
        for field in evs.dtype.names:
            if field in excluded_field:
                continue
            try:
                newevs[field] = evs[field]
            except ValueError:
                if ((field == 'stimAmp') and
                    (np.all(np.array(evs[field],np.str)=='X'))):
                    evs[field].fill(np.nan)
                    newevs[field] = evs[field]
                else: # not sure what's going on, so raise the same error as above
                    newevs[field] = evs[field]
        # append these events to recarray of all events:
        if all_evs is None:
            all_evs = newevs
        else:
            all_evs = np.r_[all_evs, newevs]
    np.save(ev_params[exp]['outfile'], all_evs)



