import seaborn as sns
import matplotlib.pyplot as plt

def cm2inch(*tupl):
    inch = 2.54
    if isinstance(tupl[0], tuple):
        return tuple(i/inch for i in tupl[0])
    else:
        return tuple(i/inch for i in tupl)

counts = [41,
          43,
          29,
          11,
          46,
          44,
          30,
          18]

x = [1,2,3,4,5,6,7,8]

rois = ['IFG','MFG','SFG','MTL','TC','IPC','SPC','OC']
sns.set_style('ticks')
colors = ['#afd4e9', '#93c68c', '#bca379', '#4d4d4d', '#e96d4c', '#f99f53', '#885f9c', '#b55c2f']

f, ax = plt.subplots(1, 1, sharex='col', sharey='row', figsize=cm2inch(5.8, 4.0))

sns.barplot(x=x, y=counts, ax=ax, palette=sns.color_palette(colors))
ax.set_xticklabels(rois)
ax.set(ylabel='Subject Count (N)')
sns.despine()
plt.tight_layout()

ax.set_xticklabels(ax.get_xticklabels(), rotation=90)

plt.plot([0, 8.5],[51, 51], linewidth=1, linestyle='--', color='grey')

f.savefig('figs/roi_coverage.eps',dpi=500)