function prep_univ_results()
%PREP_UNIV_RESULTS wrapper to generate intermediate univariate results

%% retrieval results
catfr_power_dir = 'data/RAM_catFR1_power/retrieval/hdf5_files_subj/';
fr_power_dir = 'data/RAM_FR1_power/retrieval/hdf5_files_subj/';
enc_flag = false;

[st_fr_rec, st_catfr_rec, h_fr_rec, h_catfr_rec ] = prep_univ_results(catfr_power_dir,...
    fr_power_dir,...
    enc_flag);

%% encoding results
catfr_power_dir = 'data/RAM_catFR1_power/encoding/hdf5_files_subj/';
fr_power_dir = 'data/RAM_FR1_power/encoding/hdf5_files_subj/';
enc_flag = true;

[st_fr_enc, st_catfr_enc, h_fr_enc, h_catfr_enc ] = prep_univ_results(catfr_power_dir,...
    fr_power_dir,...
    enc_flag);

% and then write to hdf5

h5create('data/catfr_enc.hdf5','/data/tstat', size(squeeze(st_catfr_enc.tstat)));
h5create('data/catfr_enc.hdf5','/data/h', size(squeeze(h_catfr_enc)));

h5write('data/catfr_enc.hdf5','/data/tstat',squeeze(st_catfr_enc.tstat));
h5write('data/catfr_enc.hdf5','/data/h',squeeze(double(h_catfr_enc)));

h5create('data/catfr_rec.hdf5','/data/tstat', size(squeeze(st_catfr_rec.tstat)));
h5create('data/catfr_rec.hdf5','/data/h', size(squeeze(h_catfr_rec)));

h5write('data/catfr_rec.hdf5','/data/tstat',squeeze(st_catfr_rec.tstat));
h5write('data/catfr_rec.hdf5','/data/h',squeeze(double(h_catfr_rec)));


h5create('data/fr_enc.hdf5','/data/tstat', size(squeeze(st_fr_enc.tstat)));
h5create('fr_enc.hdf5','/data/h', size(squeeze(h_fr_enc)));

h5write('data/fr_enc.hdf5','/data/tstat',squeeze(st_fr_enc.tstat));
h5write('data/fr_enc.hdf5','/data/h',squeeze(double(h_fr_enc)));

h5create('data/fr_rec.hdf5','/data/tstat', size(squeeze(st_fr_rec.tstat)));
h5create('data/fr_rec.hdf5','/data/h', size(squeeze(h_fr_rec)));

h5write('data/fr_rec.hdf5','/data/tstat',squeeze(st_fr_rec.tstat));
h5write('data/fr_rec.hdf5','/data/h',squeeze(double(h_fr_rec)));


end

